using System;
using System.Data;

using RAD.AppFramework.QueryObjects;

using NorthwindSample.BusinessWebService;
using NorthwindSample.BusinessServiceInterfaces.Base;
using NorthwindSample.Data;

namespace NorthwindSample.DatabaseDirectWrapper.Base
{
	public class EmployeeTerritoriesDatabaseDirectWrapperBase : IEmployeeTerritoriesServiceBase
	{
		#region Fields

		EmployeeTerritoriesService m_ServiceInstance;
		
		#endregion


		#region Constructors

		public EmployeeTerritoriesDatabaseDirectWrapperBase() 
		{
			m_ServiceInstance = new EmployeeTerritoriesService(); 
		}

		#endregion
		
		
		#region Protected Properties

		protected EmployeeTerritoriesService ServiceInstance
		{
			get { return m_ServiceInstance; }
		}


		#endregion
		

		#region Public Methods

		public int GetAll(EmployeeTerritoriesDataSet dataSetFill) 
		{
			DataTable resultsTable = ServiceInstance.GetAll().Tables[0];
			dataSetFill.Merge(resultsTable);
			return resultsTable.Rows.Count;
		}


		public int GetByQuery(DataSet dataSetFill, Query queryDefinition) 
		{
			DataTable resultsTable = ServiceInstance.GetByQuery(queryDefinition).Tables[0];
			dataSetFill.Merge(resultsTable);
			return resultsTable.Rows.Count;
		}


		public int UpdateDataSet(EmployeeTerritoriesDataSet dataSetUpdate)
		{
			DataSet returnedDataSet = ServiceInstance.UpdateDataSet(dataSetUpdate);
			return returnedDataSet.Tables[0].Rows.Count;
		}
		
			
		public int GetByEmployeeIDAndTerritoryID(EmployeeTerritoriesDataSet dataSetFill, Int32 EmployeeID, String TerritoryID)
		{
			DataTable resultsTable = ServiceInstance.GetByEmployeeIDAndTerritoryID(EmployeeID, TerritoryID).Tables[0];
			dataSetFill.Merge(resultsTable);
			return resultsTable.Rows.Count;
		}
	
		
		public int GetByEmployeeID(EmployeeTerritoriesDataSet dataSetFill, Int32 EmployeeID)
		{
			DataTable resultsTable = ServiceInstance.GetByEmployeeID(EmployeeID).Tables[0];
			dataSetFill.Merge(resultsTable);
			return resultsTable.Rows.Count;
		}
	
		
		public int GetByTerritoryID(EmployeeTerritoriesDataSet dataSetFill, String TerritoryID)
		{
			DataTable resultsTable = ServiceInstance.GetByTerritoryID(TerritoryID).Tables[0];
			dataSetFill.Merge(resultsTable);
			return resultsTable.Rows.Count;
		}
	

		
		#endregion
	}
}
