using System;
using System.Data;

using RAD.AppFramework.QueryObjects;

using NorthwindSample.BusinessWebService;
using NorthwindSample.BusinessServiceInterfaces.Base;
using NorthwindSample.Data;

namespace NorthwindSample.DatabaseDirectWrapper.Base
{
	public class OrdersDatabaseDirectWrapperBase : IOrdersServiceBase
	{
		#region Fields

		OrdersService m_ServiceInstance;
		
		#endregion


		#region Constructors

		public OrdersDatabaseDirectWrapperBase() 
		{
			m_ServiceInstance = new OrdersService(); 
		}

		#endregion
		
		
		#region Protected Properties

		protected OrdersService ServiceInstance
		{
			get { return m_ServiceInstance; }
		}


		#endregion
		

		#region Public Methods

		public int GetAll(OrdersDataSet dataSetFill) 
		{
			DataTable resultsTable = ServiceInstance.GetAll().Tables[0];
			dataSetFill.Merge(resultsTable);
			return resultsTable.Rows.Count;
		}


		public int GetByQuery(DataSet dataSetFill, Query queryDefinition) 
		{
			DataTable resultsTable = ServiceInstance.GetByQuery(queryDefinition).Tables[0];
			dataSetFill.Merge(resultsTable);
			return resultsTable.Rows.Count;
		}


		public int UpdateDataSet(OrdersDataSet dataSetUpdate)
		{
			DataSet returnedDataSet = ServiceInstance.UpdateDataSet(dataSetUpdate);
			return returnedDataSet.Tables[0].Rows.Count;
		}
		
			
		public int GetByOrderID(OrdersDataSet dataSetFill, Int32 OrderID)
		{
			DataTable resultsTable = ServiceInstance.GetByOrderID(OrderID).Tables[0];
			dataSetFill.Merge(resultsTable);
			return resultsTable.Rows.Count;
		}
	
		
		public int GetByCustomerID(OrdersDataSet dataSetFill, String CustomerID)
		{
			DataTable resultsTable = ServiceInstance.GetByCustomerID(CustomerID).Tables[0];
			dataSetFill.Merge(resultsTable);
			return resultsTable.Rows.Count;
		}
	
		
		public int GetByEmployeeID(OrdersDataSet dataSetFill, Int32 EmployeeID)
		{
			DataTable resultsTable = ServiceInstance.GetByEmployeeID(EmployeeID).Tables[0];
			dataSetFill.Merge(resultsTable);
			return resultsTable.Rows.Count;
		}
	
		
		public int GetByShipVia(OrdersDataSet dataSetFill, Int32 ShipVia)
		{
			DataTable resultsTable = ServiceInstance.GetByShipVia(ShipVia).Tables[0];
			dataSetFill.Merge(resultsTable);
			return resultsTable.Rows.Count;
		}
	

		
		#endregion
	}
}
