using System;
using System.Data;

using RAD.AppFramework.QueryObjects;

using NorthwindSample.Data;

namespace NorthwindSample.BusinessServiceInterfaces.Base
{
	/// <summary>
	/// CustomerDemographicsServiceBase defines the methods that are automatically generated for Business services.
	/// </summary>
	/// <remarks>
	/// Any additional functionality must be added to the CustomerDemographicsService class.
	/// <br/><br/>
	/// This class was automatically generated by Rad Software NextGeneration <a href="http://www.radsoftware.com.au">http://www.radsoftware.com.au</a>
	/// </remarks>
	public interface ICustomerDemographicsServiceBase
	{
		/// <summary>
		/// Fills the DataSet with all rows from the CustomerDemographics table
		/// </summary>
		/// <param name="dataSetFill">The DataSet to fill</param>
		/// <returns>A count of the rows selected</returns>
		int GetAll(CustomerDemographicsDataSet dataSetFill);
		
		/// <summary>
		/// Fills a DataSet based on a Query definition
		/// </summary>
		/// <param name="dataSetFill">The DataSet to return the rows into</param>
		/// <param name="queryDefinition">A Query object that defines the query</param>
		/// <returns>A count of the rows added to the DataSet</returns>
		int GetByQuery(DataSet dataSetFill, Query queryDefinition);
		
		/// <summary>
		/// Perform any inserts, updates or deletes on the DataSet
		/// </summary>
		/// <param name="dataSetUpdate">The DataSet to update</param>
		/// <returns>The number of rows updated</returns>
		int UpdateDataSet(CustomerDemographicsDataSet dataSetUpdate);
		
			
		/// <summary>
		/// Return all rows from the CustomerDemographics table by Primary Key
		/// </summary>
		/// <param name="dataSetFill">The DataSet to return the rows into</param>
		/// <param name="CustomerTypeID">The CustomerTypeID to use as search criteria</param>
		/// <returns>The number of rows added to the DataSet</returns>
		int GetByCustomerTypeID(CustomerDemographicsDataSet dataSetFill, String CustomerTypeID);
	
	}
}
