using System;
using System.Data;

using RAD.AppFramework.QueryObjects;

using NorthwindSample.Data;

namespace NorthwindSample.BusinessServiceInterfaces.Base
{
	/// <summary>
	/// OrdersServiceBase defines the methods that are automatically generated for Business services.
	/// </summary>
	/// <remarks>
	/// Any additional functionality must be added to the OrdersService class.
	/// <br/><br/>
	/// This class was automatically generated by Rad Software NextGeneration <a href="http://www.radsoftware.com.au">http://www.radsoftware.com.au</a>
	/// </remarks>
	public interface IOrdersServiceBase
	{
		/// <summary>
		/// Fills the DataSet with all rows from the Orders table
		/// </summary>
		/// <param name="dataSetFill">The DataSet to fill</param>
		/// <returns>A count of the rows selected</returns>
		int GetAll(OrdersDataSet dataSetFill);
		
		/// <summary>
		/// Fills a DataSet based on a Query definition
		/// </summary>
		/// <param name="dataSetFill">The DataSet to return the rows into</param>
		/// <param name="queryDefinition">A Query object that defines the query</param>
		/// <returns>A count of the rows added to the DataSet</returns>
		int GetByQuery(DataSet dataSetFill, Query queryDefinition);
		
		/// <summary>
		/// Perform any inserts, updates or deletes on the DataSet
		/// </summary>
		/// <param name="dataSetUpdate">The DataSet to update</param>
		/// <returns>The number of rows updated</returns>
		int UpdateDataSet(OrdersDataSet dataSetUpdate);
		
			
		/// <summary>
		/// Return all rows from the Orders table by Primary Key
		/// </summary>
		/// <param name="dataSetFill">The DataSet to return the rows into</param>
		/// <param name="OrderID">The OrderID to use as search criteria</param>
		/// <returns>The number of rows added to the DataSet</returns>
		int GetByOrderID(OrdersDataSet dataSetFill, Int32 OrderID);
		
		/// <summary>
		/// Return all rows from the Orders table by CustomerID
		/// </summary>
		/// <param name="dataSetFill">The DataSet to return the rows into</param>
		/// <param name="CustomerID">The CustomerID to use as search criteria</param>
		/// <returns>The number of rows added to the DataSet</returns>
		int GetByCustomerID(OrdersDataSet dataSetFill, String CustomerID);
		
		/// <summary>
		/// Return all rows from the Orders table by EmployeeID
		/// </summary>
		/// <param name="dataSetFill">The DataSet to return the rows into</param>
		/// <param name="EmployeeID">The EmployeeID to use as search criteria</param>
		/// <returns>The number of rows added to the DataSet</returns>
		int GetByEmployeeID(OrdersDataSet dataSetFill, Int32 EmployeeID);
		
		/// <summary>
		/// Return all rows from the Orders table by ShipVia
		/// </summary>
		/// <param name="dataSetFill">The DataSet to return the rows into</param>
		/// <param name="ShipVia">The ShipVia to use as search criteria</param>
		/// <returns>The number of rows added to the DataSet</returns>
		int GetByShipVia(OrdersDataSet dataSetFill, Int32 ShipVia);
	
	}
}
