using System;
using System.Data;

using RAD.AppFramework.QueryObjects;

using NorthwindSample.Data;

namespace NorthwindSample.BusinessServiceInterfaces.Base
{
	/// <summary>
	/// TerritoriesServiceBase defines the methods that are automatically generated for Business services.
	/// </summary>
	/// <remarks>
	/// Any additional functionality must be added to the TerritoriesService class.
	/// <br/><br/>
	/// This class was automatically generated by Rad Software NextGeneration <a href="http://www.radsoftware.com.au">http://www.radsoftware.com.au</a>
	/// </remarks>
	public interface ITerritoriesServiceBase
	{
		/// <summary>
		/// Fills the DataSet with all rows from the Territories table
		/// </summary>
		/// <param name="dataSetFill">The DataSet to fill</param>
		/// <returns>A count of the rows selected</returns>
		int GetAll(TerritoriesDataSet dataSetFill);
		
		/// <summary>
		/// Fills a DataSet based on a Query definition
		/// </summary>
		/// <param name="dataSetFill">The DataSet to return the rows into</param>
		/// <param name="queryDefinition">A Query object that defines the query</param>
		/// <returns>A count of the rows added to the DataSet</returns>
		int GetByQuery(DataSet dataSetFill, Query queryDefinition);
		
		/// <summary>
		/// Perform any inserts, updates or deletes on the DataSet
		/// </summary>
		/// <param name="dataSetUpdate">The DataSet to update</param>
		/// <returns>The number of rows updated</returns>
		int UpdateDataSet(TerritoriesDataSet dataSetUpdate);
		
			
		/// <summary>
		/// Return all rows from the Territories table by Primary Key
		/// </summary>
		/// <param name="dataSetFill">The DataSet to return the rows into</param>
		/// <param name="TerritoryID">The TerritoryID to use as search criteria</param>
		/// <returns>The number of rows added to the DataSet</returns>
		int GetByTerritoryID(TerritoriesDataSet dataSetFill, String TerritoryID);
		
		/// <summary>
		/// Return all rows from the Territories table by RegionID
		/// </summary>
		/// <param name="dataSetFill">The DataSet to return the rows into</param>
		/// <param name="RegionID">The RegionID to use as search criteria</param>
		/// <returns>The number of rows added to the DataSet</returns>
		int GetByRegionID(TerritoriesDataSet dataSetFill, Int32 RegionID);
	
	}
}
