Imports System

Imports RAD.AppFramework.QueryObjects

Imports NorthwindSample.BusinessServiceInterfaces.Base

Imports NorthwindSample.Data
Imports NorthwindSample.WebServiceWrapper.CustomerCustomerDemoWebService

Namespace Base

	Public Class CustomerCustomerDemoWebServiceWrapperBase 
		Implements ICustomerCustomerDemoServiceBase


#Region "Fields"

		Protected m_UrlBase As String
		Private m_ServiceInstance As CustomerCustomerDemoService

#End Region


#Region "Constructors"

		Public Sub New(ByVal urlBase As String) 

			m_UrlBase = urlBase
			m_ServiceInstance = CreateServiceInstance()
			
		End Sub

#End Region


#Region "Protected Properties"

		Protected ReadOnly Property ServiceInstance() As CustomerCustomerDemoService
			Get
				Return m_ServiceInstance
			End Get
		End Property

#End Region


#Region "Protected Methods"

		Protected Overridable Function CreateServiceInstance() As CustomerCustomerDemoService

			Dim instance As New CustomerCustomerDemoService()
			instance.Url = m_UrlBase & "CustomerCustomerDemoService.asmx"

			InitializeInstance(instance)

			Return instance
			
		End Function
		

		'
		' InitializeInstance can be used to set security credentials
		'
		Protected Overridable Sub InitializeInstance(ByVal instance As CustomerCustomerDemoService)

		End Sub
		
		
#End Region


#Region "Public Methods"

		Public Function GetAll(ByVal dataSetFill As CustomerCustomerDemoDataSet) As Integer _
			Implements ICustomerCustomerDemoServiceBase.GetAll

			Dim resultsTable As DataTable = ServiceInstance.GetAll().Tables(0)
			dataSetFill.Merge(resultsTable)
			Return resultsTable.Rows.Count
		
		End Function


		Public Function GetByQuery(ByVal dataSetFill As DataSet, ByVal queryDefinition As Query) As Integer _
			Implements ICustomerCustomerDemoServiceBase.GetByQuery

			Dim resultsTable As DataTable = ServiceInstance.GetByQuery(queryDefinition).Tables(0)
			dataSetFill.Merge(resultsTable)
			Return resultsTable.Rows.Count
		
		End Function
		
		
		Public Function UpdateDataSet(ByVal dataSetUpdate As CustomerCustomerDemoDataSet) As Integer _
			Implements ICustomerCustomerDemoServiceBase.UpdateDataSet

			Dim returnedDataSet As DataSet = ServiceInstance.UpdateDataSet(dataSetUpdate)

			Dim recordCount As Integer = returnedDataSet.Tables(0).Rows.Count

			If recordCount > 0 Then

				'
				' Need to clear the dataset as Merge does not work with new rows 
				' that have a primary key assigned automatically
				'
				dataSetUpdate.Clear()
                dataSetUpdate.Merge(returnedDataSet)

            End If

            Return recordCount

        End Function
			
		Public Function GetByCustomerIDAndCustomerTypeID(ByVal dataSetFill As CustomerCustomerDemoDataSet, ByVal CustomerID As String, ByVal CustomerTypeID As String) As Integer _
			Implements ICustomerCustomerDemoServiceBase.GetByCustomerIDAndCustomerTypeID

			Dim resultsTable As DataTable = ServiceInstance.GetByCustomerIDAndCustomerTypeID(CustomerID, CustomerTypeID).Tables(0)
			dataSetFill.Merge(resultsTable)
			Return resultsTable.Rows.Count
			
		End Function
	
		
		Public Function GetByCustomerTypeID(ByVal dataSetFill As CustomerCustomerDemoDataSet, ByVal CustomerTypeID As String) As Integer _
			Implements ICustomerCustomerDemoServiceBase.GetByCustomerTypeID

			Dim resultsTable As DataTable = ServiceInstance.GetByCustomerTypeID(CustomerTypeID).Tables(0)
			dataSetFill.Merge(resultsTable)
			Return resultsTable.Rows.Count
			
		End Function
	
		
		Public Function GetByCustomerID(ByVal dataSetFill As CustomerCustomerDemoDataSet, ByVal CustomerID As String) As Integer _
			Implements ICustomerCustomerDemoServiceBase.GetByCustomerID

			Dim resultsTable As DataTable = ServiceInstance.GetByCustomerID(CustomerID).Tables(0)
			dataSetFill.Merge(resultsTable)
			Return resultsTable.Rows.Count
			
		End Function
	

		
#End Region
		
	End Class
	
End Namespace
