using System;
using System.Data;
using System.Data.OleDb;
using System.Data.SqlClient;
using System.Collections;

using RAD.AppFramework.Data;
using RAD.AppFramework.QueryObjects;

using NorthwindSample.Common;
using NorthwindSample.DataAccess;

namespace NorthwindSample.DataAccess.Readers.Base
{
	/// <summary>
	/// Base class for the CategoriesDataReader
	/// <seealso cref="CategoriesDataReader"/>
	/// </summary>
	/// <remarks>
	/// Provides forward-only read access to the Categories table.
	/// 
	/// This class has been auto-generated and should not be modified. Any modifications should
	/// be made to the <see cref="CategoriesDataReader">CategoriesDataReader</see> class.
	/// <br/><br/>
	/// This class was automatically generated by Rad Software NextGeneration <a href="http://www.radsoftware.com.au">http://www.radsoftware.com.au</a>
	/// </remarks>
	public class CategoriesDataReaderBase : StronglyTypedDataReader
	{		
		#region Fields
	
		/// <summary>The ordinal position of the CategoryID column in the result set</summary>
		protected int m_CategoryIDOrdinal;
		/// <summary>The ordinal position of the CategoryName column in the result set</summary>
		protected int m_CategoryNameOrdinal;
		/// <summary>The ordinal position of the Description column in the result set</summary>
		protected int m_DescriptionOrdinal;
		/// <summary>The ordinal position of the Picture column in the result set</summary>
		protected int m_PictureOrdinal;
			
		#endregion
		
		
		#region Constructors
		
		/// <summary>
		/// Creates a new CategoriesDataReaderBase
		/// </summary>
		public CategoriesDataReaderBase()
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();
		
			Connection = DataObjectFactory.CreateConnection();
		}
		
		#endregion
		

		#region Column Attributes


		/// <summary>
		/// Returns the value of the CategoryID column for the current row
		/// </summary>
		public Int32 CategoryID
		{
			get 
			{
					return (Int32)DataRecord[m_CategoryIDOrdinal];
			}
		}
	
		/// <summary>
		/// Returns the value of the CategoryName column for the current row
		/// </summary>
		public String CategoryName
		{
			get 
			{
					return (String)DataRecord[m_CategoryNameOrdinal];
			}
		}
	
		/// <summary>
		/// Returns the value of the Description column for the current row
		/// </summary>
		public String Description
		{
			get 
			{
				try
				{
					return (String)DataRecord[m_DescriptionOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the Picture column for the current row
		/// </summary>
		public Byte[] Picture
		{
			get 
			{
				try
				{
					return (Byte[])DataRecord[m_PictureOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	

		#endregion

		
		#region Private Methods
		
		/// <summary>
		/// Sets the indexes of the columns within the result set
		/// </summary>
		protected override void SetColumnOrdinals()
		{
			m_CategoryIDOrdinal = DataReader.GetOrdinal("CategoryID");
			m_CategoryNameOrdinal = DataReader.GetOrdinal("CategoryName");
			m_DescriptionOrdinal = DataReader.GetOrdinal("Description");
			m_PictureOrdinal = DataReader.GetOrdinal("Picture");
		}
		
		#endregion
		
		
		#region Public Methods
		
		/// <summary>
		/// Selects all rows from the Categories table
		/// </summary>
		/// <returns>true on success, false otherwise</returns>
		public bool SelectAll()
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();
		
			CommandSelect = DataObjectFactory.CreateCommand(Connection, CommandType.StoredProcedure);
			CommandSelect.CommandText = "gspCategories_SelectAll";
			
			return OpenReader();
		}
		
		/// <summary>
		/// Selects rows from the Categories table by Query definion
		/// </summary>
		/// <param name="queryDefinition">A Query object that defines the Query used to select rows from the database</param>
		/// <returns>true on success, false otherwise</returns>
		public bool SelectByQuery(Query queryDefinition)
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();

			CommandSelect = DataObjectFactory.CreateCommand(Connection, CommandType.Text);

			if (queryDefinition.TableName.Length == 0)
			{
				queryDefinition.TableName = "gvwCategories";
			}

			queryDefinition.BuildCommand(CommandSelect);

			return OpenReader();
		}
		
		
		/// <summary>
		/// Selects rows from the Categories table by Primary Key (CategoryID)
		/// </summary>
		/// <param name="CategoryID">The CategoryID to use as search criteria</param>
		/// <returns>true on success, false otherwise</returns>
		public bool SelectByCategoryID(Int32 CategoryID)
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();
		
			CommandSelect = DataObjectFactory.CreateCommand(Connection, CommandType.StoredProcedure);
			CommandSelect.CommandText = "gspCategories_SelectByCategoryID";
			
			CommandSelect.Parameters.Add(DataObjectFactory.CreateCommandParameter("@CategoryID", SqlDbType.Int, CategoryID));
			
			return OpenReader();
		}
		
		/// <summary>
		/// Checks if the value of the Description column is NULL
		/// </summary>
		/// <returns>true if Description is NULL, false if it is not NULL</returns>
		public bool IsDescriptionNull()
		{
			return DataRecord.IsDBNull(m_DescriptionOrdinal);
		}
		
		/// <summary>
		/// Checks if the value of the Picture column is NULL
		/// </summary>
		/// <returns>true if Picture is NULL, false if it is not NULL</returns>
		public bool IsPictureNull()
		{
			return DataRecord.IsDBNull(m_PictureOrdinal);
		}
		
		
		
		
		#endregion
	}
}
