using System;
using System.Data;
using System.Data.OleDb;
using System.Data.SqlClient;
using System.Collections;

using RAD.AppFramework.Data;
using RAD.AppFramework.QueryObjects;

using NorthwindSample.Common;
using NorthwindSample.DataAccess;

namespace NorthwindSample.DataAccess.Readers.Base
{
	/// <summary>
	/// Base class for the CustomerCustomerDemoDataReader
	/// <seealso cref="CustomerCustomerDemoDataReader"/>
	/// </summary>
	/// <remarks>
	/// Provides forward-only read access to the CustomerCustomerDemo table.
	/// 
	/// This class has been auto-generated and should not be modified. Any modifications should
	/// be made to the <see cref="CustomerCustomerDemoDataReader">CustomerCustomerDemoDataReader</see> class.
	/// <br/><br/>
	/// This class was automatically generated by Rad Software NextGeneration <a href="http://www.radsoftware.com.au">http://www.radsoftware.com.au</a>
	/// </remarks>
	public class CustomerCustomerDemoDataReaderBase : StronglyTypedDataReader
	{		
		#region Fields
	
		/// <summary>The ordinal position of the CustomerID column in the result set</summary>
		protected int m_CustomerIDOrdinal;
		/// <summary>The ordinal position of the CustomerTypeID column in the result set</summary>
		protected int m_CustomerTypeIDOrdinal;
			
		#endregion
		
		
		#region Constructors
		
		/// <summary>
		/// Creates a new CustomerCustomerDemoDataReaderBase
		/// </summary>
		public CustomerCustomerDemoDataReaderBase()
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();
		
			Connection = DataObjectFactory.CreateConnection();
		}
		
		#endregion
		

		#region Column Attributes


		/// <summary>
		/// Returns the value of the CustomerID column for the current row
		/// </summary>
		public String CustomerID
		{
			get 
			{
					return (String)DataRecord[m_CustomerIDOrdinal];
			}
		}
	
		/// <summary>
		/// Returns the value of the CustomerTypeID column for the current row
		/// </summary>
		public String CustomerTypeID
		{
			get 
			{
					return (String)DataRecord[m_CustomerTypeIDOrdinal];
			}
		}
	

		#endregion

		
		#region Private Methods
		
		/// <summary>
		/// Sets the indexes of the columns within the result set
		/// </summary>
		protected override void SetColumnOrdinals()
		{
			m_CustomerIDOrdinal = DataReader.GetOrdinal("CustomerID");
			m_CustomerTypeIDOrdinal = DataReader.GetOrdinal("CustomerTypeID");
		}
		
		#endregion
		
		
		#region Public Methods
		
		/// <summary>
		/// Selects all rows from the CustomerCustomerDemo table
		/// </summary>
		/// <returns>true on success, false otherwise</returns>
		public bool SelectAll()
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();
		
			CommandSelect = DataObjectFactory.CreateCommand(Connection, CommandType.StoredProcedure);
			CommandSelect.CommandText = "gspCustomerCustomerDemo_SelectAll";
			
			return OpenReader();
		}
		
		/// <summary>
		/// Selects rows from the CustomerCustomerDemo table by Query definion
		/// </summary>
		/// <param name="queryDefinition">A Query object that defines the Query used to select rows from the database</param>
		/// <returns>true on success, false otherwise</returns>
		public bool SelectByQuery(Query queryDefinition)
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();

			CommandSelect = DataObjectFactory.CreateCommand(Connection, CommandType.Text);

			if (queryDefinition.TableName.Length == 0)
			{
				queryDefinition.TableName = "gvwCustomerCustomerDemo";
			}

			queryDefinition.BuildCommand(CommandSelect);

			return OpenReader();
		}
		
		
		/// <summary>
		/// Selects rows from the CustomerCustomerDemo table by Primary Key (CustomerID, CustomerTypeID)
		/// </summary>
		/// <param name="CustomerID">The CustomerID to use as search criteria</param>
		/// <param name="CustomerTypeID">The CustomerTypeID to use as search criteria</param>
		/// <returns>true on success, false otherwise</returns>
		public bool SelectByCustomerIDAndCustomerTypeID(String CustomerID, String CustomerTypeID)
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();
		
			CommandSelect = DataObjectFactory.CreateCommand(Connection, CommandType.StoredProcedure);
			CommandSelect.CommandText = "gspCustomerCustomerDemo_SelectByCustomerIDAndCustomerTypeID";
			
			CommandSelect.Parameters.Add(DataObjectFactory.CreateCommandParameter("@CustomerID", SqlDbType.NChar, 5, CustomerID));
			CommandSelect.Parameters.Add(DataObjectFactory.CreateCommandParameter("@CustomerTypeID", SqlDbType.NChar, 10, CustomerTypeID));
			
			return OpenReader();
		}
		
		/// <summary>
		/// Selects rows from the CustomerCustomerDemo table by CustomerTypeID
		/// </summary>
		/// <param name="CustomerTypeID">The CustomerTypeID to use as search criteria</param>
		/// <returns>true on success, false otherwise</returns>
		public bool SelectByCustomerTypeID(String CustomerTypeID)
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();
		
			CommandSelect = DataObjectFactory.CreateCommand(Connection, CommandType.StoredProcedure);
			CommandSelect.CommandText = "gspCustomerCustomerDemo_SelectByCustomerTypeID";
			
			CommandSelect.Parameters.Add(DataObjectFactory.CreateCommandParameter("@CustomerTypeID", SqlDbType.NChar, 10, CustomerTypeID));
			
			return OpenReader();
		}
		
		/// <summary>
		/// Selects rows from the CustomerCustomerDemo table by CustomerID
		/// </summary>
		/// <param name="CustomerID">The CustomerID to use as search criteria</param>
		/// <returns>true on success, false otherwise</returns>
		public bool SelectByCustomerID(String CustomerID)
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();
		
			CommandSelect = DataObjectFactory.CreateCommand(Connection, CommandType.StoredProcedure);
			CommandSelect.CommandText = "gspCustomerCustomerDemo_SelectByCustomerID";
			
			CommandSelect.Parameters.Add(DataObjectFactory.CreateCommandParameter("@CustomerID", SqlDbType.NChar, 5, CustomerID));
			
			return OpenReader();
		}
		
		
		
		
		#endregion
	}
}
