using System;
using System.Data;
using System.Data.OleDb;
using System.Data.SqlClient;
using System.Collections;

using RAD.AppFramework.Data;
using RAD.AppFramework.QueryObjects;

using NorthwindSample.Common;
using NorthwindSample.DataAccess;

namespace NorthwindSample.DataAccess.Readers.Base
{
	/// <summary>
	/// Base class for the CustomerDemographicsDataReader
	/// <seealso cref="CustomerDemographicsDataReader"/>
	/// </summary>
	/// <remarks>
	/// Provides forward-only read access to the CustomerDemographics table.
	/// 
	/// This class has been auto-generated and should not be modified. Any modifications should
	/// be made to the <see cref="CustomerDemographicsDataReader">CustomerDemographicsDataReader</see> class.
	/// <br/><br/>
	/// This class was automatically generated by Rad Software NextGeneration <a href="http://www.radsoftware.com.au">http://www.radsoftware.com.au</a>
	/// </remarks>
	public class CustomerDemographicsDataReaderBase : StronglyTypedDataReader
	{		
		#region Fields
	
		/// <summary>The ordinal position of the CustomerTypeID column in the result set</summary>
		protected int m_CustomerTypeIDOrdinal;
		/// <summary>The ordinal position of the CustomerDesc column in the result set</summary>
		protected int m_CustomerDescOrdinal;
			
		#endregion
		
		
		#region Constructors
		
		/// <summary>
		/// Creates a new CustomerDemographicsDataReaderBase
		/// </summary>
		public CustomerDemographicsDataReaderBase()
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();
		
			Connection = DataObjectFactory.CreateConnection();
		}
		
		#endregion
		

		#region Column Attributes


		/// <summary>
		/// Returns the value of the CustomerTypeID column for the current row
		/// </summary>
		public String CustomerTypeID
		{
			get 
			{
					return (String)DataRecord[m_CustomerTypeIDOrdinal];
			}
		}
	
		/// <summary>
		/// Returns the value of the CustomerDesc column for the current row
		/// </summary>
		public String CustomerDesc
		{
			get 
			{
				try
				{
					return (String)DataRecord[m_CustomerDescOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	

		#endregion

		
		#region Private Methods
		
		/// <summary>
		/// Sets the indexes of the columns within the result set
		/// </summary>
		protected override void SetColumnOrdinals()
		{
			m_CustomerTypeIDOrdinal = DataReader.GetOrdinal("CustomerTypeID");
			m_CustomerDescOrdinal = DataReader.GetOrdinal("CustomerDesc");
		}
		
		#endregion
		
		
		#region Public Methods
		
		/// <summary>
		/// Selects all rows from the CustomerDemographics table
		/// </summary>
		/// <returns>true on success, false otherwise</returns>
		public bool SelectAll()
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();
		
			CommandSelect = DataObjectFactory.CreateCommand(Connection, CommandType.StoredProcedure);
			CommandSelect.CommandText = "gspCustomerDemographics_SelectAll";
			
			return OpenReader();
		}
		
		/// <summary>
		/// Selects rows from the CustomerDemographics table by Query definion
		/// </summary>
		/// <param name="queryDefinition">A Query object that defines the Query used to select rows from the database</param>
		/// <returns>true on success, false otherwise</returns>
		public bool SelectByQuery(Query queryDefinition)
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();

			CommandSelect = DataObjectFactory.CreateCommand(Connection, CommandType.Text);

			if (queryDefinition.TableName.Length == 0)
			{
				queryDefinition.TableName = "gvwCustomerDemographics";
			}

			queryDefinition.BuildCommand(CommandSelect);

			return OpenReader();
		}
		
		
		/// <summary>
		/// Selects rows from the CustomerDemographics table by Primary Key (CustomerTypeID)
		/// </summary>
		/// <param name="CustomerTypeID">The CustomerTypeID to use as search criteria</param>
		/// <returns>true on success, false otherwise</returns>
		public bool SelectByCustomerTypeID(String CustomerTypeID)
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();
		
			CommandSelect = DataObjectFactory.CreateCommand(Connection, CommandType.StoredProcedure);
			CommandSelect.CommandText = "gspCustomerDemographics_SelectByCustomerTypeID";
			
			CommandSelect.Parameters.Add(DataObjectFactory.CreateCommandParameter("@CustomerTypeID", SqlDbType.NChar, 10, CustomerTypeID));
			
			return OpenReader();
		}
		
		/// <summary>
		/// Checks if the value of the CustomerDesc column is NULL
		/// </summary>
		/// <returns>true if CustomerDesc is NULL, false if it is not NULL</returns>
		public bool IsCustomerDescNull()
		{
			return DataRecord.IsDBNull(m_CustomerDescOrdinal);
		}
		
		
		
		
		#endregion
	}
}
