using System;
using System.Data;
using System.Data.OleDb;
using System.Data.SqlClient;
using System.Collections;

using RAD.AppFramework.Data;
using RAD.AppFramework.QueryObjects;

using NorthwindSample.Common;
using NorthwindSample.DataAccess;

namespace NorthwindSample.DataAccess.Readers.Base
{
	/// <summary>
	/// Base class for the EmployeeTerritoriesDataReader
	/// <seealso cref="EmployeeTerritoriesDataReader"/>
	/// </summary>
	/// <remarks>
	/// Provides forward-only read access to the EmployeeTerritories table.
	/// 
	/// This class has been auto-generated and should not be modified. Any modifications should
	/// be made to the <see cref="EmployeeTerritoriesDataReader">EmployeeTerritoriesDataReader</see> class.
	/// <br/><br/>
	/// This class was automatically generated by Rad Software NextGeneration <a href="http://www.radsoftware.com.au">http://www.radsoftware.com.au</a>
	/// </remarks>
	public class EmployeeTerritoriesDataReaderBase : StronglyTypedDataReader
	{		
		#region Fields
	
		/// <summary>The ordinal position of the EmployeeID column in the result set</summary>
		protected int m_EmployeeIDOrdinal;
		/// <summary>The ordinal position of the TerritoryID column in the result set</summary>
		protected int m_TerritoryIDOrdinal;
			
		#endregion
		
		
		#region Constructors
		
		/// <summary>
		/// Creates a new EmployeeTerritoriesDataReaderBase
		/// </summary>
		public EmployeeTerritoriesDataReaderBase()
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();
		
			Connection = DataObjectFactory.CreateConnection();
		}
		
		#endregion
		

		#region Column Attributes


		/// <summary>
		/// Returns the value of the EmployeeID column for the current row
		/// </summary>
		public Int32 EmployeeID
		{
			get 
			{
					return (Int32)DataRecord[m_EmployeeIDOrdinal];
			}
		}
	
		/// <summary>
		/// Returns the value of the TerritoryID column for the current row
		/// </summary>
		public String TerritoryID
		{
			get 
			{
					return (String)DataRecord[m_TerritoryIDOrdinal];
			}
		}
	

		#endregion

		
		#region Private Methods
		
		/// <summary>
		/// Sets the indexes of the columns within the result set
		/// </summary>
		protected override void SetColumnOrdinals()
		{
			m_EmployeeIDOrdinal = DataReader.GetOrdinal("EmployeeID");
			m_TerritoryIDOrdinal = DataReader.GetOrdinal("TerritoryID");
		}
		
		#endregion
		
		
		#region Public Methods
		
		/// <summary>
		/// Selects all rows from the EmployeeTerritories table
		/// </summary>
		/// <returns>true on success, false otherwise</returns>
		public bool SelectAll()
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();
		
			CommandSelect = DataObjectFactory.CreateCommand(Connection, CommandType.StoredProcedure);
			CommandSelect.CommandText = "gspEmployeeTerritories_SelectAll";
			
			return OpenReader();
		}
		
		/// <summary>
		/// Selects rows from the EmployeeTerritories table by Query definion
		/// </summary>
		/// <param name="queryDefinition">A Query object that defines the Query used to select rows from the database</param>
		/// <returns>true on success, false otherwise</returns>
		public bool SelectByQuery(Query queryDefinition)
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();

			CommandSelect = DataObjectFactory.CreateCommand(Connection, CommandType.Text);

			if (queryDefinition.TableName.Length == 0)
			{
				queryDefinition.TableName = "gvwEmployeeTerritories";
			}

			queryDefinition.BuildCommand(CommandSelect);

			return OpenReader();
		}
		
		
		/// <summary>
		/// Selects rows from the EmployeeTerritories table by Primary Key (EmployeeID, TerritoryID)
		/// </summary>
		/// <param name="EmployeeID">The EmployeeID to use as search criteria</param>
		/// <param name="TerritoryID">The TerritoryID to use as search criteria</param>
		/// <returns>true on success, false otherwise</returns>
		public bool SelectByEmployeeIDAndTerritoryID(Int32 EmployeeID, String TerritoryID)
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();
		
			CommandSelect = DataObjectFactory.CreateCommand(Connection, CommandType.StoredProcedure);
			CommandSelect.CommandText = "gspEmployeeTerritories_SelectByEmployeeIDAndTerritoryID";
			
			CommandSelect.Parameters.Add(DataObjectFactory.CreateCommandParameter("@EmployeeID", SqlDbType.Int, EmployeeID));
			CommandSelect.Parameters.Add(DataObjectFactory.CreateCommandParameter("@TerritoryID", SqlDbType.NVarChar, 20, TerritoryID));
			
			return OpenReader();
		}
		
		/// <summary>
		/// Selects rows from the EmployeeTerritories table by EmployeeID
		/// </summary>
		/// <param name="EmployeeID">The EmployeeID to use as search criteria</param>
		/// <returns>true on success, false otherwise</returns>
		public bool SelectByEmployeeID(Int32 EmployeeID)
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();
		
			CommandSelect = DataObjectFactory.CreateCommand(Connection, CommandType.StoredProcedure);
			CommandSelect.CommandText = "gspEmployeeTerritories_SelectByEmployeeID";
			
			CommandSelect.Parameters.Add(DataObjectFactory.CreateCommandParameter("@EmployeeID", SqlDbType.Int, EmployeeID));
			
			return OpenReader();
		}
		
		/// <summary>
		/// Selects rows from the EmployeeTerritories table by TerritoryID
		/// </summary>
		/// <param name="TerritoryID">The TerritoryID to use as search criteria</param>
		/// <returns>true on success, false otherwise</returns>
		public bool SelectByTerritoryID(String TerritoryID)
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();
		
			CommandSelect = DataObjectFactory.CreateCommand(Connection, CommandType.StoredProcedure);
			CommandSelect.CommandText = "gspEmployeeTerritories_SelectByTerritoryID";
			
			CommandSelect.Parameters.Add(DataObjectFactory.CreateCommandParameter("@TerritoryID", SqlDbType.NVarChar, 20, TerritoryID));
			
			return OpenReader();
		}
		
		
		
		
		#endregion
	}
}
