using System;
using System.Data;
using System.Data.OleDb;
using System.Data.SqlClient;
using System.Collections;

using RAD.AppFramework.Data;
using RAD.AppFramework.QueryObjects;

using NorthwindSample.Common;
using NorthwindSample.DataAccess;

namespace NorthwindSample.DataAccess.Readers.Base
{
	/// <summary>
	/// Base class for the EmployeesDataReader
	/// <seealso cref="EmployeesDataReader"/>
	/// </summary>
	/// <remarks>
	/// Provides forward-only read access to the Employees table.
	/// 
	/// This class has been auto-generated and should not be modified. Any modifications should
	/// be made to the <see cref="EmployeesDataReader">EmployeesDataReader</see> class.
	/// <br/><br/>
	/// This class was automatically generated by Rad Software NextGeneration <a href="http://www.radsoftware.com.au">http://www.radsoftware.com.au</a>
	/// </remarks>
	public class EmployeesDataReaderBase : StronglyTypedDataReader
	{		
		#region Fields
	
		/// <summary>The ordinal position of the EmployeeID column in the result set</summary>
		protected int m_EmployeeIDOrdinal;
		/// <summary>The ordinal position of the LastName column in the result set</summary>
		protected int m_LastNameOrdinal;
		/// <summary>The ordinal position of the FirstName column in the result set</summary>
		protected int m_FirstNameOrdinal;
		/// <summary>The ordinal position of the Title column in the result set</summary>
		protected int m_TitleOrdinal;
		/// <summary>The ordinal position of the TitleOfCourtesy column in the result set</summary>
		protected int m_TitleOfCourtesyOrdinal;
		/// <summary>The ordinal position of the BirthDate column in the result set</summary>
		protected int m_BirthDateOrdinal;
		/// <summary>The ordinal position of the HireDate column in the result set</summary>
		protected int m_HireDateOrdinal;
		/// <summary>The ordinal position of the Address column in the result set</summary>
		protected int m_AddressOrdinal;
		/// <summary>The ordinal position of the City column in the result set</summary>
		protected int m_CityOrdinal;
		/// <summary>The ordinal position of the Region column in the result set</summary>
		protected int m_RegionOrdinal;
		/// <summary>The ordinal position of the PostalCode column in the result set</summary>
		protected int m_PostalCodeOrdinal;
		/// <summary>The ordinal position of the Country column in the result set</summary>
		protected int m_CountryOrdinal;
		/// <summary>The ordinal position of the HomePhone column in the result set</summary>
		protected int m_HomePhoneOrdinal;
		/// <summary>The ordinal position of the Extension column in the result set</summary>
		protected int m_ExtensionOrdinal;
		/// <summary>The ordinal position of the Photo column in the result set</summary>
		protected int m_PhotoOrdinal;
		/// <summary>The ordinal position of the Notes column in the result set</summary>
		protected int m_NotesOrdinal;
		/// <summary>The ordinal position of the ReportsTo column in the result set</summary>
		protected int m_ReportsToOrdinal;
		/// <summary>The ordinal position of the PhotoPath column in the result set</summary>
		protected int m_PhotoPathOrdinal;
			
		#endregion
		
		
		#region Constructors
		
		/// <summary>
		/// Creates a new EmployeesDataReaderBase
		/// </summary>
		public EmployeesDataReaderBase()
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();
		
			Connection = DataObjectFactory.CreateConnection();
		}
		
		#endregion
		

		#region Column Attributes


		/// <summary>
		/// Returns the value of the EmployeeID column for the current row
		/// </summary>
		public Int32 EmployeeID
		{
			get 
			{
					return (Int32)DataRecord[m_EmployeeIDOrdinal];
			}
		}
	
		/// <summary>
		/// Returns the value of the LastName column for the current row
		/// </summary>
		public String LastName
		{
			get 
			{
					return (String)DataRecord[m_LastNameOrdinal];
			}
		}
	
		/// <summary>
		/// Returns the value of the FirstName column for the current row
		/// </summary>
		public String FirstName
		{
			get 
			{
					return (String)DataRecord[m_FirstNameOrdinal];
			}
		}
	
		/// <summary>
		/// Returns the value of the Title column for the current row
		/// </summary>
		public String Title
		{
			get 
			{
				try
				{
					return (String)DataRecord[m_TitleOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the TitleOfCourtesy column for the current row
		/// </summary>
		public String TitleOfCourtesy
		{
			get 
			{
				try
				{
					return (String)DataRecord[m_TitleOfCourtesyOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the BirthDate column for the current row
		/// </summary>
		public DateTime BirthDate
		{
			get 
			{
				try
				{
					return (DateTime)DataRecord[m_BirthDateOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the HireDate column for the current row
		/// </summary>
		public DateTime HireDate
		{
			get 
			{
				try
				{
					return (DateTime)DataRecord[m_HireDateOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the Address column for the current row
		/// </summary>
		public String Address
		{
			get 
			{
				try
				{
					return (String)DataRecord[m_AddressOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the City column for the current row
		/// </summary>
		public String City
		{
			get 
			{
				try
				{
					return (String)DataRecord[m_CityOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the Region column for the current row
		/// </summary>
		public String Region
		{
			get 
			{
				try
				{
					return (String)DataRecord[m_RegionOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the PostalCode column for the current row
		/// </summary>
		public String PostalCode
		{
			get 
			{
				try
				{
					return (String)DataRecord[m_PostalCodeOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the Country column for the current row
		/// </summary>
		public String Country
		{
			get 
			{
				try
				{
					return (String)DataRecord[m_CountryOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the HomePhone column for the current row
		/// </summary>
		public String HomePhone
		{
			get 
			{
				try
				{
					return (String)DataRecord[m_HomePhoneOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the Extension column for the current row
		/// </summary>
		public String Extension
		{
			get 
			{
				try
				{
					return (String)DataRecord[m_ExtensionOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the Photo column for the current row
		/// </summary>
		public Byte[] Photo
		{
			get 
			{
				try
				{
					return (Byte[])DataRecord[m_PhotoOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the Notes column for the current row
		/// </summary>
		public String Notes
		{
			get 
			{
				try
				{
					return (String)DataRecord[m_NotesOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the ReportsTo column for the current row
		/// </summary>
		public Int32 ReportsTo
		{
			get 
			{
				try
				{
					return (Int32)DataRecord[m_ReportsToOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the PhotoPath column for the current row
		/// </summary>
		public String PhotoPath
		{
			get 
			{
				try
				{
					return (String)DataRecord[m_PhotoPathOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	

		#endregion

		
		#region Private Methods
		
		/// <summary>
		/// Sets the indexes of the columns within the result set
		/// </summary>
		protected override void SetColumnOrdinals()
		{
			m_EmployeeIDOrdinal = DataReader.GetOrdinal("EmployeeID");
			m_LastNameOrdinal = DataReader.GetOrdinal("LastName");
			m_FirstNameOrdinal = DataReader.GetOrdinal("FirstName");
			m_TitleOrdinal = DataReader.GetOrdinal("Title");
			m_TitleOfCourtesyOrdinal = DataReader.GetOrdinal("TitleOfCourtesy");
			m_BirthDateOrdinal = DataReader.GetOrdinal("BirthDate");
			m_HireDateOrdinal = DataReader.GetOrdinal("HireDate");
			m_AddressOrdinal = DataReader.GetOrdinal("Address");
			m_CityOrdinal = DataReader.GetOrdinal("City");
			m_RegionOrdinal = DataReader.GetOrdinal("Region");
			m_PostalCodeOrdinal = DataReader.GetOrdinal("PostalCode");
			m_CountryOrdinal = DataReader.GetOrdinal("Country");
			m_HomePhoneOrdinal = DataReader.GetOrdinal("HomePhone");
			m_ExtensionOrdinal = DataReader.GetOrdinal("Extension");
			m_PhotoOrdinal = DataReader.GetOrdinal("Photo");
			m_NotesOrdinal = DataReader.GetOrdinal("Notes");
			m_ReportsToOrdinal = DataReader.GetOrdinal("ReportsTo");
			m_PhotoPathOrdinal = DataReader.GetOrdinal("PhotoPath");
		}
		
		#endregion
		
		
		#region Public Methods
		
		/// <summary>
		/// Selects all rows from the Employees table
		/// </summary>
		/// <returns>true on success, false otherwise</returns>
		public bool SelectAll()
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();
		
			CommandSelect = DataObjectFactory.CreateCommand(Connection, CommandType.StoredProcedure);
			CommandSelect.CommandText = "gspEmployees_SelectAll";
			
			return OpenReader();
		}
		
		/// <summary>
		/// Selects rows from the Employees table by Query definion
		/// </summary>
		/// <param name="queryDefinition">A Query object that defines the Query used to select rows from the database</param>
		/// <returns>true on success, false otherwise</returns>
		public bool SelectByQuery(Query queryDefinition)
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();

			CommandSelect = DataObjectFactory.CreateCommand(Connection, CommandType.Text);

			if (queryDefinition.TableName.Length == 0)
			{
				queryDefinition.TableName = "gvwEmployees";
			}

			queryDefinition.BuildCommand(CommandSelect);

			return OpenReader();
		}
		
		
		/// <summary>
		/// Selects rows from the Employees table by Primary Key (EmployeeID)
		/// </summary>
		/// <param name="EmployeeID">The EmployeeID to use as search criteria</param>
		/// <returns>true on success, false otherwise</returns>
		public bool SelectByEmployeeID(Int32 EmployeeID)
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();
		
			CommandSelect = DataObjectFactory.CreateCommand(Connection, CommandType.StoredProcedure);
			CommandSelect.CommandText = "gspEmployees_SelectByEmployeeID";
			
			CommandSelect.Parameters.Add(DataObjectFactory.CreateCommandParameter("@EmployeeID", SqlDbType.Int, EmployeeID));
			
			return OpenReader();
		}
		
		/// <summary>
		/// Selects rows from the Employees table by ReportsTo
		/// </summary>
		/// <param name="ReportsTo">The ReportsTo to use as search criteria</param>
		/// <returns>true on success, false otherwise</returns>
		public bool SelectByReportsTo(Int32 ReportsTo)
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();
		
			CommandSelect = DataObjectFactory.CreateCommand(Connection, CommandType.StoredProcedure);
			CommandSelect.CommandText = "gspEmployees_SelectByReportsTo";
			
			CommandSelect.Parameters.Add(DataObjectFactory.CreateCommandParameter("@ReportsTo", SqlDbType.Int, ReportsTo));
			
			return OpenReader();
		}
		
		/// <summary>
		/// Checks if the value of the Title column is NULL
		/// </summary>
		/// <returns>true if Title is NULL, false if it is not NULL</returns>
		public bool IsTitleNull()
		{
			return DataRecord.IsDBNull(m_TitleOrdinal);
		}
		
		/// <summary>
		/// Checks if the value of the TitleOfCourtesy column is NULL
		/// </summary>
		/// <returns>true if TitleOfCourtesy is NULL, false if it is not NULL</returns>
		public bool IsTitleOfCourtesyNull()
		{
			return DataRecord.IsDBNull(m_TitleOfCourtesyOrdinal);
		}
		
		/// <summary>
		/// Checks if the value of the BirthDate column is NULL
		/// </summary>
		/// <returns>true if BirthDate is NULL, false if it is not NULL</returns>
		public bool IsBirthDateNull()
		{
			return DataRecord.IsDBNull(m_BirthDateOrdinal);
		}
		
		/// <summary>
		/// Checks if the value of the HireDate column is NULL
		/// </summary>
		/// <returns>true if HireDate is NULL, false if it is not NULL</returns>
		public bool IsHireDateNull()
		{
			return DataRecord.IsDBNull(m_HireDateOrdinal);
		}
		
		/// <summary>
		/// Checks if the value of the Address column is NULL
		/// </summary>
		/// <returns>true if Address is NULL, false if it is not NULL</returns>
		public bool IsAddressNull()
		{
			return DataRecord.IsDBNull(m_AddressOrdinal);
		}
		
		/// <summary>
		/// Checks if the value of the City column is NULL
		/// </summary>
		/// <returns>true if City is NULL, false if it is not NULL</returns>
		public bool IsCityNull()
		{
			return DataRecord.IsDBNull(m_CityOrdinal);
		}
		
		/// <summary>
		/// Checks if the value of the Region column is NULL
		/// </summary>
		/// <returns>true if Region is NULL, false if it is not NULL</returns>
		public bool IsRegionNull()
		{
			return DataRecord.IsDBNull(m_RegionOrdinal);
		}
		
		/// <summary>
		/// Checks if the value of the PostalCode column is NULL
		/// </summary>
		/// <returns>true if PostalCode is NULL, false if it is not NULL</returns>
		public bool IsPostalCodeNull()
		{
			return DataRecord.IsDBNull(m_PostalCodeOrdinal);
		}
		
		/// <summary>
		/// Checks if the value of the Country column is NULL
		/// </summary>
		/// <returns>true if Country is NULL, false if it is not NULL</returns>
		public bool IsCountryNull()
		{
			return DataRecord.IsDBNull(m_CountryOrdinal);
		}
		
		/// <summary>
		/// Checks if the value of the HomePhone column is NULL
		/// </summary>
		/// <returns>true if HomePhone is NULL, false if it is not NULL</returns>
		public bool IsHomePhoneNull()
		{
			return DataRecord.IsDBNull(m_HomePhoneOrdinal);
		}
		
		/// <summary>
		/// Checks if the value of the Extension column is NULL
		/// </summary>
		/// <returns>true if Extension is NULL, false if it is not NULL</returns>
		public bool IsExtensionNull()
		{
			return DataRecord.IsDBNull(m_ExtensionOrdinal);
		}
		
		/// <summary>
		/// Checks if the value of the Photo column is NULL
		/// </summary>
		/// <returns>true if Photo is NULL, false if it is not NULL</returns>
		public bool IsPhotoNull()
		{
			return DataRecord.IsDBNull(m_PhotoOrdinal);
		}
		
		/// <summary>
		/// Checks if the value of the Notes column is NULL
		/// </summary>
		/// <returns>true if Notes is NULL, false if it is not NULL</returns>
		public bool IsNotesNull()
		{
			return DataRecord.IsDBNull(m_NotesOrdinal);
		}
		
		/// <summary>
		/// Checks if the value of the ReportsTo column is NULL
		/// </summary>
		/// <returns>true if ReportsTo is NULL, false if it is not NULL</returns>
		public bool IsReportsToNull()
		{
			return DataRecord.IsDBNull(m_ReportsToOrdinal);
		}
		
		/// <summary>
		/// Checks if the value of the PhotoPath column is NULL
		/// </summary>
		/// <returns>true if PhotoPath is NULL, false if it is not NULL</returns>
		public bool IsPhotoPathNull()
		{
			return DataRecord.IsDBNull(m_PhotoPathOrdinal);
		}
		
		
		
		
		#endregion
	}
}
