using System;
using System.Data;
using System.Data.OleDb;
using System.Data.SqlClient;
using System.Collections;

using RAD.AppFramework.Data;
using RAD.AppFramework.QueryObjects;

using NorthwindSample.Common;
using NorthwindSample.DataAccess;

namespace NorthwindSample.DataAccess.Readers.Base
{
	/// <summary>
	/// Base class for the OrdersDataReader
	/// <seealso cref="OrdersDataReader"/>
	/// </summary>
	/// <remarks>
	/// Provides forward-only read access to the Orders table.
	/// 
	/// This class has been auto-generated and should not be modified. Any modifications should
	/// be made to the <see cref="OrdersDataReader">OrdersDataReader</see> class.
	/// <br/><br/>
	/// This class was automatically generated by Rad Software NextGeneration <a href="http://www.radsoftware.com.au">http://www.radsoftware.com.au</a>
	/// </remarks>
	public class OrdersDataReaderBase : StronglyTypedDataReader
	{		
		#region Fields
	
		/// <summary>The ordinal position of the OrderID column in the result set</summary>
		protected int m_OrderIDOrdinal;
		/// <summary>The ordinal position of the CustomerID column in the result set</summary>
		protected int m_CustomerIDOrdinal;
		/// <summary>The ordinal position of the EmployeeID column in the result set</summary>
		protected int m_EmployeeIDOrdinal;
		/// <summary>The ordinal position of the OrderDate column in the result set</summary>
		protected int m_OrderDateOrdinal;
		/// <summary>The ordinal position of the RequiredDate column in the result set</summary>
		protected int m_RequiredDateOrdinal;
		/// <summary>The ordinal position of the ShippedDate column in the result set</summary>
		protected int m_ShippedDateOrdinal;
		/// <summary>The ordinal position of the ShipVia column in the result set</summary>
		protected int m_ShipViaOrdinal;
		/// <summary>The ordinal position of the Freight column in the result set</summary>
		protected int m_FreightOrdinal;
		/// <summary>The ordinal position of the ShipName column in the result set</summary>
		protected int m_ShipNameOrdinal;
		/// <summary>The ordinal position of the ShipAddress column in the result set</summary>
		protected int m_ShipAddressOrdinal;
		/// <summary>The ordinal position of the ShipCity column in the result set</summary>
		protected int m_ShipCityOrdinal;
		/// <summary>The ordinal position of the ShipRegion column in the result set</summary>
		protected int m_ShipRegionOrdinal;
		/// <summary>The ordinal position of the ShipPostalCode column in the result set</summary>
		protected int m_ShipPostalCodeOrdinal;
		/// <summary>The ordinal position of the ShipCountry column in the result set</summary>
		protected int m_ShipCountryOrdinal;
			
		#endregion
		
		
		#region Constructors
		
		/// <summary>
		/// Creates a new OrdersDataReaderBase
		/// </summary>
		public OrdersDataReaderBase()
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();
		
			Connection = DataObjectFactory.CreateConnection();
		}
		
		#endregion
		

		#region Column Attributes


		/// <summary>
		/// Returns the value of the OrderID column for the current row
		/// </summary>
		public Int32 OrderID
		{
			get 
			{
					return (Int32)DataRecord[m_OrderIDOrdinal];
			}
		}
	
		/// <summary>
		/// Returns the value of the CustomerID column for the current row
		/// </summary>
		public String CustomerID
		{
			get 
			{
				try
				{
					return (String)DataRecord[m_CustomerIDOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the EmployeeID column for the current row
		/// </summary>
		public Int32 EmployeeID
		{
			get 
			{
				try
				{
					return (Int32)DataRecord[m_EmployeeIDOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the OrderDate column for the current row
		/// </summary>
		public DateTime OrderDate
		{
			get 
			{
				try
				{
					return (DateTime)DataRecord[m_OrderDateOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the RequiredDate column for the current row
		/// </summary>
		public DateTime RequiredDate
		{
			get 
			{
				try
				{
					return (DateTime)DataRecord[m_RequiredDateOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the ShippedDate column for the current row
		/// </summary>
		public DateTime ShippedDate
		{
			get 
			{
				try
				{
					return (DateTime)DataRecord[m_ShippedDateOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the ShipVia column for the current row
		/// </summary>
		public Int32 ShipVia
		{
			get 
			{
				try
				{
					return (Int32)DataRecord[m_ShipViaOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the Freight column for the current row
		/// </summary>
		public Decimal Freight
		{
			get 
			{
				try
				{
					return (Decimal)DataRecord[m_FreightOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the ShipName column for the current row
		/// </summary>
		public String ShipName
		{
			get 
			{
				try
				{
					return (String)DataRecord[m_ShipNameOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the ShipAddress column for the current row
		/// </summary>
		public String ShipAddress
		{
			get 
			{
				try
				{
					return (String)DataRecord[m_ShipAddressOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the ShipCity column for the current row
		/// </summary>
		public String ShipCity
		{
			get 
			{
				try
				{
					return (String)DataRecord[m_ShipCityOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the ShipRegion column for the current row
		/// </summary>
		public String ShipRegion
		{
			get 
			{
				try
				{
					return (String)DataRecord[m_ShipRegionOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the ShipPostalCode column for the current row
		/// </summary>
		public String ShipPostalCode
		{
			get 
			{
				try
				{
					return (String)DataRecord[m_ShipPostalCodeOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the ShipCountry column for the current row
		/// </summary>
		public String ShipCountry
		{
			get 
			{
				try
				{
					return (String)DataRecord[m_ShipCountryOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	

		#endregion

		
		#region Private Methods
		
		/// <summary>
		/// Sets the indexes of the columns within the result set
		/// </summary>
		protected override void SetColumnOrdinals()
		{
			m_OrderIDOrdinal = DataReader.GetOrdinal("OrderID");
			m_CustomerIDOrdinal = DataReader.GetOrdinal("CustomerID");
			m_EmployeeIDOrdinal = DataReader.GetOrdinal("EmployeeID");
			m_OrderDateOrdinal = DataReader.GetOrdinal("OrderDate");
			m_RequiredDateOrdinal = DataReader.GetOrdinal("RequiredDate");
			m_ShippedDateOrdinal = DataReader.GetOrdinal("ShippedDate");
			m_ShipViaOrdinal = DataReader.GetOrdinal("ShipVia");
			m_FreightOrdinal = DataReader.GetOrdinal("Freight");
			m_ShipNameOrdinal = DataReader.GetOrdinal("ShipName");
			m_ShipAddressOrdinal = DataReader.GetOrdinal("ShipAddress");
			m_ShipCityOrdinal = DataReader.GetOrdinal("ShipCity");
			m_ShipRegionOrdinal = DataReader.GetOrdinal("ShipRegion");
			m_ShipPostalCodeOrdinal = DataReader.GetOrdinal("ShipPostalCode");
			m_ShipCountryOrdinal = DataReader.GetOrdinal("ShipCountry");
		}
		
		#endregion
		
		
		#region Public Methods
		
		/// <summary>
		/// Selects all rows from the Orders table
		/// </summary>
		/// <returns>true on success, false otherwise</returns>
		public bool SelectAll()
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();
		
			CommandSelect = DataObjectFactory.CreateCommand(Connection, CommandType.StoredProcedure);
			CommandSelect.CommandText = "gspOrders_SelectAll";
			
			return OpenReader();
		}
		
		/// <summary>
		/// Selects rows from the Orders table by Query definion
		/// </summary>
		/// <param name="queryDefinition">A Query object that defines the Query used to select rows from the database</param>
		/// <returns>true on success, false otherwise</returns>
		public bool SelectByQuery(Query queryDefinition)
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();

			CommandSelect = DataObjectFactory.CreateCommand(Connection, CommandType.Text);

			if (queryDefinition.TableName.Length == 0)
			{
				queryDefinition.TableName = "gvwOrders";
			}

			queryDefinition.BuildCommand(CommandSelect);

			return OpenReader();
		}
		
		
		/// <summary>
		/// Selects rows from the Orders table by Primary Key (OrderID)
		/// </summary>
		/// <param name="OrderID">The OrderID to use as search criteria</param>
		/// <returns>true on success, false otherwise</returns>
		public bool SelectByOrderID(Int32 OrderID)
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();
		
			CommandSelect = DataObjectFactory.CreateCommand(Connection, CommandType.StoredProcedure);
			CommandSelect.CommandText = "gspOrders_SelectByOrderID";
			
			CommandSelect.Parameters.Add(DataObjectFactory.CreateCommandParameter("@OrderID", SqlDbType.Int, OrderID));
			
			return OpenReader();
		}
		
		/// <summary>
		/// Selects rows from the Orders table by CustomerID
		/// </summary>
		/// <param name="CustomerID">The CustomerID to use as search criteria</param>
		/// <returns>true on success, false otherwise</returns>
		public bool SelectByCustomerID(String CustomerID)
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();
		
			CommandSelect = DataObjectFactory.CreateCommand(Connection, CommandType.StoredProcedure);
			CommandSelect.CommandText = "gspOrders_SelectByCustomerID";
			
			CommandSelect.Parameters.Add(DataObjectFactory.CreateCommandParameter("@CustomerID", SqlDbType.NChar, 5, CustomerID));
			
			return OpenReader();
		}
		
		/// <summary>
		/// Selects rows from the Orders table by EmployeeID
		/// </summary>
		/// <param name="EmployeeID">The EmployeeID to use as search criteria</param>
		/// <returns>true on success, false otherwise</returns>
		public bool SelectByEmployeeID(Int32 EmployeeID)
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();
		
			CommandSelect = DataObjectFactory.CreateCommand(Connection, CommandType.StoredProcedure);
			CommandSelect.CommandText = "gspOrders_SelectByEmployeeID";
			
			CommandSelect.Parameters.Add(DataObjectFactory.CreateCommandParameter("@EmployeeID", SqlDbType.Int, EmployeeID));
			
			return OpenReader();
		}
		
		/// <summary>
		/// Selects rows from the Orders table by ShipVia
		/// </summary>
		/// <param name="ShipVia">The ShipVia to use as search criteria</param>
		/// <returns>true on success, false otherwise</returns>
		public bool SelectByShipVia(Int32 ShipVia)
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();
		
			CommandSelect = DataObjectFactory.CreateCommand(Connection, CommandType.StoredProcedure);
			CommandSelect.CommandText = "gspOrders_SelectByShipVia";
			
			CommandSelect.Parameters.Add(DataObjectFactory.CreateCommandParameter("@ShipVia", SqlDbType.Int, ShipVia));
			
			return OpenReader();
		}
		
		/// <summary>
		/// Checks if the value of the CustomerID column is NULL
		/// </summary>
		/// <returns>true if CustomerID is NULL, false if it is not NULL</returns>
		public bool IsCustomerIDNull()
		{
			return DataRecord.IsDBNull(m_CustomerIDOrdinal);
		}
		
		/// <summary>
		/// Checks if the value of the EmployeeID column is NULL
		/// </summary>
		/// <returns>true if EmployeeID is NULL, false if it is not NULL</returns>
		public bool IsEmployeeIDNull()
		{
			return DataRecord.IsDBNull(m_EmployeeIDOrdinal);
		}
		
		/// <summary>
		/// Checks if the value of the OrderDate column is NULL
		/// </summary>
		/// <returns>true if OrderDate is NULL, false if it is not NULL</returns>
		public bool IsOrderDateNull()
		{
			return DataRecord.IsDBNull(m_OrderDateOrdinal);
		}
		
		/// <summary>
		/// Checks if the value of the RequiredDate column is NULL
		/// </summary>
		/// <returns>true if RequiredDate is NULL, false if it is not NULL</returns>
		public bool IsRequiredDateNull()
		{
			return DataRecord.IsDBNull(m_RequiredDateOrdinal);
		}
		
		/// <summary>
		/// Checks if the value of the ShippedDate column is NULL
		/// </summary>
		/// <returns>true if ShippedDate is NULL, false if it is not NULL</returns>
		public bool IsShippedDateNull()
		{
			return DataRecord.IsDBNull(m_ShippedDateOrdinal);
		}
		
		/// <summary>
		/// Checks if the value of the ShipVia column is NULL
		/// </summary>
		/// <returns>true if ShipVia is NULL, false if it is not NULL</returns>
		public bool IsShipViaNull()
		{
			return DataRecord.IsDBNull(m_ShipViaOrdinal);
		}
		
		/// <summary>
		/// Checks if the value of the Freight column is NULL
		/// </summary>
		/// <returns>true if Freight is NULL, false if it is not NULL</returns>
		public bool IsFreightNull()
		{
			return DataRecord.IsDBNull(m_FreightOrdinal);
		}
		
		/// <summary>
		/// Checks if the value of the ShipName column is NULL
		/// </summary>
		/// <returns>true if ShipName is NULL, false if it is not NULL</returns>
		public bool IsShipNameNull()
		{
			return DataRecord.IsDBNull(m_ShipNameOrdinal);
		}
		
		/// <summary>
		/// Checks if the value of the ShipAddress column is NULL
		/// </summary>
		/// <returns>true if ShipAddress is NULL, false if it is not NULL</returns>
		public bool IsShipAddressNull()
		{
			return DataRecord.IsDBNull(m_ShipAddressOrdinal);
		}
		
		/// <summary>
		/// Checks if the value of the ShipCity column is NULL
		/// </summary>
		/// <returns>true if ShipCity is NULL, false if it is not NULL</returns>
		public bool IsShipCityNull()
		{
			return DataRecord.IsDBNull(m_ShipCityOrdinal);
		}
		
		/// <summary>
		/// Checks if the value of the ShipRegion column is NULL
		/// </summary>
		/// <returns>true if ShipRegion is NULL, false if it is not NULL</returns>
		public bool IsShipRegionNull()
		{
			return DataRecord.IsDBNull(m_ShipRegionOrdinal);
		}
		
		/// <summary>
		/// Checks if the value of the ShipPostalCode column is NULL
		/// </summary>
		/// <returns>true if ShipPostalCode is NULL, false if it is not NULL</returns>
		public bool IsShipPostalCodeNull()
		{
			return DataRecord.IsDBNull(m_ShipPostalCodeOrdinal);
		}
		
		/// <summary>
		/// Checks if the value of the ShipCountry column is NULL
		/// </summary>
		/// <returns>true if ShipCountry is NULL, false if it is not NULL</returns>
		public bool IsShipCountryNull()
		{
			return DataRecord.IsDBNull(m_ShipCountryOrdinal);
		}
		
		
		
		
		#endregion
	}
}
