using System;
using System.Data;
using System.Data.OleDb;
using System.Data.SqlClient;
using System.Collections;

using RAD.AppFramework.Data;
using RAD.AppFramework.QueryObjects;

using NorthwindSample.Common;
using NorthwindSample.DataAccess;

namespace NorthwindSample.DataAccess.Readers.Base
{
	/// <summary>
	/// Base class for the ProductsDataReader
	/// <seealso cref="ProductsDataReader"/>
	/// </summary>
	/// <remarks>
	/// Provides forward-only read access to the Products table.
	/// 
	/// This class has been auto-generated and should not be modified. Any modifications should
	/// be made to the <see cref="ProductsDataReader">ProductsDataReader</see> class.
	/// <br/><br/>
	/// This class was automatically generated by Rad Software NextGeneration <a href="http://www.radsoftware.com.au">http://www.radsoftware.com.au</a>
	/// </remarks>
	public class ProductsDataReaderBase : StronglyTypedDataReader
	{		
		#region Fields
	
		/// <summary>The ordinal position of the ProductID column in the result set</summary>
		protected int m_ProductIDOrdinal;
		/// <summary>The ordinal position of the ProductName column in the result set</summary>
		protected int m_ProductNameOrdinal;
		/// <summary>The ordinal position of the SupplierID column in the result set</summary>
		protected int m_SupplierIDOrdinal;
		/// <summary>The ordinal position of the CategoryID column in the result set</summary>
		protected int m_CategoryIDOrdinal;
		/// <summary>The ordinal position of the QuantityPerUnit column in the result set</summary>
		protected int m_QuantityPerUnitOrdinal;
		/// <summary>The ordinal position of the UnitPrice column in the result set</summary>
		protected int m_UnitPriceOrdinal;
		/// <summary>The ordinal position of the UnitsInStock column in the result set</summary>
		protected int m_UnitsInStockOrdinal;
		/// <summary>The ordinal position of the UnitsOnOrder column in the result set</summary>
		protected int m_UnitsOnOrderOrdinal;
		/// <summary>The ordinal position of the ReorderLevel column in the result set</summary>
		protected int m_ReorderLevelOrdinal;
		/// <summary>The ordinal position of the Discontinued column in the result set</summary>
		protected int m_DiscontinuedOrdinal;
			
		#endregion
		
		
		#region Constructors
		
		/// <summary>
		/// Creates a new ProductsDataReaderBase
		/// </summary>
		public ProductsDataReaderBase()
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();
		
			Connection = DataObjectFactory.CreateConnection();
		}
		
		#endregion
		

		#region Column Attributes


		/// <summary>
		/// Returns the value of the ProductID column for the current row
		/// </summary>
		public Int32 ProductID
		{
			get 
			{
					return (Int32)DataRecord[m_ProductIDOrdinal];
			}
		}
	
		/// <summary>
		/// Returns the value of the ProductName column for the current row
		/// </summary>
		public String ProductName
		{
			get 
			{
					return (String)DataRecord[m_ProductNameOrdinal];
			}
		}
	
		/// <summary>
		/// Returns the value of the SupplierID column for the current row
		/// </summary>
		public Int32 SupplierID
		{
			get 
			{
				try
				{
					return (Int32)DataRecord[m_SupplierIDOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the CategoryID column for the current row
		/// </summary>
		public Int32 CategoryID
		{
			get 
			{
				try
				{
					return (Int32)DataRecord[m_CategoryIDOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the QuantityPerUnit column for the current row
		/// </summary>
		public String QuantityPerUnit
		{
			get 
			{
				try
				{
					return (String)DataRecord[m_QuantityPerUnitOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the UnitPrice column for the current row
		/// </summary>
		public Decimal UnitPrice
		{
			get 
			{
				try
				{
					return (Decimal)DataRecord[m_UnitPriceOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the UnitsInStock column for the current row
		/// </summary>
		public Int16 UnitsInStock
		{
			get 
			{
				try
				{
					return (Int16)DataRecord[m_UnitsInStockOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the UnitsOnOrder column for the current row
		/// </summary>
		public Int16 UnitsOnOrder
		{
			get 
			{
				try
				{
					return (Int16)DataRecord[m_UnitsOnOrderOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the ReorderLevel column for the current row
		/// </summary>
		public Int16 ReorderLevel
		{
			get 
			{
				try
				{
					return (Int16)DataRecord[m_ReorderLevelOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the Discontinued column for the current row
		/// </summary>
		public Boolean Discontinued
		{
			get 
			{
					return (Boolean)DataRecord[m_DiscontinuedOrdinal];
			}
		}
	

		#endregion

		
		#region Private Methods
		
		/// <summary>
		/// Sets the indexes of the columns within the result set
		/// </summary>
		protected override void SetColumnOrdinals()
		{
			m_ProductIDOrdinal = DataReader.GetOrdinal("ProductID");
			m_ProductNameOrdinal = DataReader.GetOrdinal("ProductName");
			m_SupplierIDOrdinal = DataReader.GetOrdinal("SupplierID");
			m_CategoryIDOrdinal = DataReader.GetOrdinal("CategoryID");
			m_QuantityPerUnitOrdinal = DataReader.GetOrdinal("QuantityPerUnit");
			m_UnitPriceOrdinal = DataReader.GetOrdinal("UnitPrice");
			m_UnitsInStockOrdinal = DataReader.GetOrdinal("UnitsInStock");
			m_UnitsOnOrderOrdinal = DataReader.GetOrdinal("UnitsOnOrder");
			m_ReorderLevelOrdinal = DataReader.GetOrdinal("ReorderLevel");
			m_DiscontinuedOrdinal = DataReader.GetOrdinal("Discontinued");
		}
		
		#endregion
		
		
		#region Public Methods
		
		/// <summary>
		/// Selects all rows from the Products table
		/// </summary>
		/// <returns>true on success, false otherwise</returns>
		public bool SelectAll()
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();
		
			CommandSelect = DataObjectFactory.CreateCommand(Connection, CommandType.StoredProcedure);
			CommandSelect.CommandText = "gspProducts_SelectAll";
			
			return OpenReader();
		}
		
		/// <summary>
		/// Selects rows from the Products table by Query definion
		/// </summary>
		/// <param name="queryDefinition">A Query object that defines the Query used to select rows from the database</param>
		/// <returns>true on success, false otherwise</returns>
		public bool SelectByQuery(Query queryDefinition)
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();

			CommandSelect = DataObjectFactory.CreateCommand(Connection, CommandType.Text);

			if (queryDefinition.TableName.Length == 0)
			{
				queryDefinition.TableName = "gvwProducts";
			}

			queryDefinition.BuildCommand(CommandSelect);

			return OpenReader();
		}
		
		
		/// <summary>
		/// Selects rows from the Products table by Primary Key (ProductID)
		/// </summary>
		/// <param name="ProductID">The ProductID to use as search criteria</param>
		/// <returns>true on success, false otherwise</returns>
		public bool SelectByProductID(Int32 ProductID)
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();
		
			CommandSelect = DataObjectFactory.CreateCommand(Connection, CommandType.StoredProcedure);
			CommandSelect.CommandText = "gspProducts_SelectByProductID";
			
			CommandSelect.Parameters.Add(DataObjectFactory.CreateCommandParameter("@ProductID", SqlDbType.Int, ProductID));
			
			return OpenReader();
		}
		
		/// <summary>
		/// Selects rows from the Products table by CategoryID
		/// </summary>
		/// <param name="CategoryID">The CategoryID to use as search criteria</param>
		/// <returns>true on success, false otherwise</returns>
		public bool SelectByCategoryID(Int32 CategoryID)
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();
		
			CommandSelect = DataObjectFactory.CreateCommand(Connection, CommandType.StoredProcedure);
			CommandSelect.CommandText = "gspProducts_SelectByCategoryID";
			
			CommandSelect.Parameters.Add(DataObjectFactory.CreateCommandParameter("@CategoryID", SqlDbType.Int, CategoryID));
			
			return OpenReader();
		}
		
		/// <summary>
		/// Selects rows from the Products table by SupplierID
		/// </summary>
		/// <param name="SupplierID">The SupplierID to use as search criteria</param>
		/// <returns>true on success, false otherwise</returns>
		public bool SelectBySupplierID(Int32 SupplierID)
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();
		
			CommandSelect = DataObjectFactory.CreateCommand(Connection, CommandType.StoredProcedure);
			CommandSelect.CommandText = "gspProducts_SelectBySupplierID";
			
			CommandSelect.Parameters.Add(DataObjectFactory.CreateCommandParameter("@SupplierID", SqlDbType.Int, SupplierID));
			
			return OpenReader();
		}
		
		/// <summary>
		/// Checks if the value of the SupplierID column is NULL
		/// </summary>
		/// <returns>true if SupplierID is NULL, false if it is not NULL</returns>
		public bool IsSupplierIDNull()
		{
			return DataRecord.IsDBNull(m_SupplierIDOrdinal);
		}
		
		/// <summary>
		/// Checks if the value of the CategoryID column is NULL
		/// </summary>
		/// <returns>true if CategoryID is NULL, false if it is not NULL</returns>
		public bool IsCategoryIDNull()
		{
			return DataRecord.IsDBNull(m_CategoryIDOrdinal);
		}
		
		/// <summary>
		/// Checks if the value of the QuantityPerUnit column is NULL
		/// </summary>
		/// <returns>true if QuantityPerUnit is NULL, false if it is not NULL</returns>
		public bool IsQuantityPerUnitNull()
		{
			return DataRecord.IsDBNull(m_QuantityPerUnitOrdinal);
		}
		
		/// <summary>
		/// Checks if the value of the UnitPrice column is NULL
		/// </summary>
		/// <returns>true if UnitPrice is NULL, false if it is not NULL</returns>
		public bool IsUnitPriceNull()
		{
			return DataRecord.IsDBNull(m_UnitPriceOrdinal);
		}
		
		/// <summary>
		/// Checks if the value of the UnitsInStock column is NULL
		/// </summary>
		/// <returns>true if UnitsInStock is NULL, false if it is not NULL</returns>
		public bool IsUnitsInStockNull()
		{
			return DataRecord.IsDBNull(m_UnitsInStockOrdinal);
		}
		
		/// <summary>
		/// Checks if the value of the UnitsOnOrder column is NULL
		/// </summary>
		/// <returns>true if UnitsOnOrder is NULL, false if it is not NULL</returns>
		public bool IsUnitsOnOrderNull()
		{
			return DataRecord.IsDBNull(m_UnitsOnOrderOrdinal);
		}
		
		/// <summary>
		/// Checks if the value of the ReorderLevel column is NULL
		/// </summary>
		/// <returns>true if ReorderLevel is NULL, false if it is not NULL</returns>
		public bool IsReorderLevelNull()
		{
			return DataRecord.IsDBNull(m_ReorderLevelOrdinal);
		}
		
		
		
		
		#endregion
	}
}
