using System;
using System.Data;
using System.Data.OleDb;
using System.Data.SqlClient;
using System.Collections;

using RAD.AppFramework.Data;
using RAD.AppFramework.QueryObjects;

using NorthwindSample.Common;
using NorthwindSample.DataAccess;

namespace NorthwindSample.DataAccess.Readers.Base
{
	/// <summary>
	/// Base class for the RegionDataReader
	/// <seealso cref="RegionDataReader"/>
	/// </summary>
	/// <remarks>
	/// Provides forward-only read access to the Region table.
	/// 
	/// This class has been auto-generated and should not be modified. Any modifications should
	/// be made to the <see cref="RegionDataReader">RegionDataReader</see> class.
	/// <br/><br/>
	/// This class was automatically generated by Rad Software NextGeneration <a href="http://www.radsoftware.com.au">http://www.radsoftware.com.au</a>
	/// </remarks>
	public class RegionDataReaderBase : StronglyTypedDataReader
	{		
		#region Fields
	
		/// <summary>The ordinal position of the RegionID column in the result set</summary>
		protected int m_RegionIDOrdinal;
		/// <summary>The ordinal position of the RegionDescription column in the result set</summary>
		protected int m_RegionDescriptionOrdinal;
			
		#endregion
		
		
		#region Constructors
		
		/// <summary>
		/// Creates a new RegionDataReaderBase
		/// </summary>
		public RegionDataReaderBase()
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();
		
			Connection = DataObjectFactory.CreateConnection();
		}
		
		#endregion
		

		#region Column Attributes


		/// <summary>
		/// Returns the value of the RegionID column for the current row
		/// </summary>
		public Int32 RegionID
		{
			get 
			{
					return (Int32)DataRecord[m_RegionIDOrdinal];
			}
		}
	
		/// <summary>
		/// Returns the value of the RegionDescription column for the current row
		/// </summary>
		public String RegionDescription
		{
			get 
			{
					return (String)DataRecord[m_RegionDescriptionOrdinal];
			}
		}
	

		#endregion

		
		#region Private Methods
		
		/// <summary>
		/// Sets the indexes of the columns within the result set
		/// </summary>
		protected override void SetColumnOrdinals()
		{
			m_RegionIDOrdinal = DataReader.GetOrdinal("RegionID");
			m_RegionDescriptionOrdinal = DataReader.GetOrdinal("RegionDescription");
		}
		
		#endregion
		
		
		#region Public Methods
		
		/// <summary>
		/// Selects all rows from the Region table
		/// </summary>
		/// <returns>true on success, false otherwise</returns>
		public bool SelectAll()
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();
		
			CommandSelect = DataObjectFactory.CreateCommand(Connection, CommandType.StoredProcedure);
			CommandSelect.CommandText = "gspRegion_SelectAll";
			
			return OpenReader();
		}
		
		/// <summary>
		/// Selects rows from the Region table by Query definion
		/// </summary>
		/// <param name="queryDefinition">A Query object that defines the Query used to select rows from the database</param>
		/// <returns>true on success, false otherwise</returns>
		public bool SelectByQuery(Query queryDefinition)
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();

			CommandSelect = DataObjectFactory.CreateCommand(Connection, CommandType.Text);

			if (queryDefinition.TableName.Length == 0)
			{
				queryDefinition.TableName = "gvwRegion";
			}

			queryDefinition.BuildCommand(CommandSelect);

			return OpenReader();
		}
		
		
		/// <summary>
		/// Selects rows from the Region table by Primary Key (RegionID)
		/// </summary>
		/// <param name="RegionID">The RegionID to use as search criteria</param>
		/// <returns>true on success, false otherwise</returns>
		public bool SelectByRegionID(Int32 RegionID)
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();
		
			CommandSelect = DataObjectFactory.CreateCommand(Connection, CommandType.StoredProcedure);
			CommandSelect.CommandText = "gspRegion_SelectByRegionID";
			
			CommandSelect.Parameters.Add(DataObjectFactory.CreateCommandParameter("@RegionID", SqlDbType.Int, RegionID));
			
			return OpenReader();
		}
		
		
		
		
		#endregion
	}
}
