using System;
using System.Data;
using System.Data.OleDb;
using System.Data.SqlClient;
using System.Collections;

using RAD.AppFramework.Data;
using RAD.AppFramework.QueryObjects;

using NorthwindSample.Common;
using NorthwindSample.DataAccess;

namespace NorthwindSample.DataAccess.Readers.Base
{
	/// <summary>
	/// Base class for the SuppliersDataReader
	/// <seealso cref="SuppliersDataReader"/>
	/// </summary>
	/// <remarks>
	/// Provides forward-only read access to the Suppliers table.
	/// 
	/// This class has been auto-generated and should not be modified. Any modifications should
	/// be made to the <see cref="SuppliersDataReader">SuppliersDataReader</see> class.
	/// <br/><br/>
	/// This class was automatically generated by Rad Software NextGeneration <a href="http://www.radsoftware.com.au">http://www.radsoftware.com.au</a>
	/// </remarks>
	public class SuppliersDataReaderBase : StronglyTypedDataReader
	{		
		#region Fields
	
		/// <summary>The ordinal position of the SupplierID column in the result set</summary>
		protected int m_SupplierIDOrdinal;
		/// <summary>The ordinal position of the CompanyName column in the result set</summary>
		protected int m_CompanyNameOrdinal;
		/// <summary>The ordinal position of the ContactName column in the result set</summary>
		protected int m_ContactNameOrdinal;
		/// <summary>The ordinal position of the ContactTitle column in the result set</summary>
		protected int m_ContactTitleOrdinal;
		/// <summary>The ordinal position of the Address column in the result set</summary>
		protected int m_AddressOrdinal;
		/// <summary>The ordinal position of the City column in the result set</summary>
		protected int m_CityOrdinal;
		/// <summary>The ordinal position of the Region column in the result set</summary>
		protected int m_RegionOrdinal;
		/// <summary>The ordinal position of the PostalCode column in the result set</summary>
		protected int m_PostalCodeOrdinal;
		/// <summary>The ordinal position of the Country column in the result set</summary>
		protected int m_CountryOrdinal;
		/// <summary>The ordinal position of the Phone column in the result set</summary>
		protected int m_PhoneOrdinal;
		/// <summary>The ordinal position of the Fax column in the result set</summary>
		protected int m_FaxOrdinal;
		/// <summary>The ordinal position of the HomePage column in the result set</summary>
		protected int m_HomePageOrdinal;
			
		#endregion
		
		
		#region Constructors
		
		/// <summary>
		/// Creates a new SuppliersDataReaderBase
		/// </summary>
		public SuppliersDataReaderBase()
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();
		
			Connection = DataObjectFactory.CreateConnection();
		}
		
		#endregion
		

		#region Column Attributes


		/// <summary>
		/// Returns the value of the SupplierID column for the current row
		/// </summary>
		public Int32 SupplierID
		{
			get 
			{
					return (Int32)DataRecord[m_SupplierIDOrdinal];
			}
		}
	
		/// <summary>
		/// Returns the value of the CompanyName column for the current row
		/// </summary>
		public String CompanyName
		{
			get 
			{
					return (String)DataRecord[m_CompanyNameOrdinal];
			}
		}
	
		/// <summary>
		/// Returns the value of the ContactName column for the current row
		/// </summary>
		public String ContactName
		{
			get 
			{
				try
				{
					return (String)DataRecord[m_ContactNameOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the ContactTitle column for the current row
		/// </summary>
		public String ContactTitle
		{
			get 
			{
				try
				{
					return (String)DataRecord[m_ContactTitleOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the Address column for the current row
		/// </summary>
		public String Address
		{
			get 
			{
				try
				{
					return (String)DataRecord[m_AddressOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the City column for the current row
		/// </summary>
		public String City
		{
			get 
			{
				try
				{
					return (String)DataRecord[m_CityOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the Region column for the current row
		/// </summary>
		public String Region
		{
			get 
			{
				try
				{
					return (String)DataRecord[m_RegionOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the PostalCode column for the current row
		/// </summary>
		public String PostalCode
		{
			get 
			{
				try
				{
					return (String)DataRecord[m_PostalCodeOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the Country column for the current row
		/// </summary>
		public String Country
		{
			get 
			{
				try
				{
					return (String)DataRecord[m_CountryOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the Phone column for the current row
		/// </summary>
		public String Phone
		{
			get 
			{
				try
				{
					return (String)DataRecord[m_PhoneOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the Fax column for the current row
		/// </summary>
		public String Fax
		{
			get 
			{
				try
				{
					return (String)DataRecord[m_FaxOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	
		/// <summary>
		/// Returns the value of the HomePage column for the current row
		/// </summary>
		public String HomePage
		{
			get 
			{
				try
				{
					return (String)DataRecord[m_HomePageOrdinal];
				}
				catch (InvalidCastException e) 
				{
					throw new StrongTypingException("Cannot get value because it is DBNull.", e);
				}
			}
		}
	

		#endregion

		
		#region Private Methods
		
		/// <summary>
		/// Sets the indexes of the columns within the result set
		/// </summary>
		protected override void SetColumnOrdinals()
		{
			m_SupplierIDOrdinal = DataReader.GetOrdinal("SupplierID");
			m_CompanyNameOrdinal = DataReader.GetOrdinal("CompanyName");
			m_ContactNameOrdinal = DataReader.GetOrdinal("ContactName");
			m_ContactTitleOrdinal = DataReader.GetOrdinal("ContactTitle");
			m_AddressOrdinal = DataReader.GetOrdinal("Address");
			m_CityOrdinal = DataReader.GetOrdinal("City");
			m_RegionOrdinal = DataReader.GetOrdinal("Region");
			m_PostalCodeOrdinal = DataReader.GetOrdinal("PostalCode");
			m_CountryOrdinal = DataReader.GetOrdinal("Country");
			m_PhoneOrdinal = DataReader.GetOrdinal("Phone");
			m_FaxOrdinal = DataReader.GetOrdinal("Fax");
			m_HomePageOrdinal = DataReader.GetOrdinal("HomePage");
		}
		
		#endregion
		
		
		#region Public Methods
		
		/// <summary>
		/// Selects all rows from the Suppliers table
		/// </summary>
		/// <returns>true on success, false otherwise</returns>
		public bool SelectAll()
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();
		
			CommandSelect = DataObjectFactory.CreateCommand(Connection, CommandType.StoredProcedure);
			CommandSelect.CommandText = "gspSuppliers_SelectAll";
			
			return OpenReader();
		}
		
		/// <summary>
		/// Selects rows from the Suppliers table by Query definion
		/// </summary>
		/// <param name="queryDefinition">A Query object that defines the Query used to select rows from the database</param>
		/// <returns>true on success, false otherwise</returns>
		public bool SelectByQuery(Query queryDefinition)
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();

			CommandSelect = DataObjectFactory.CreateCommand(Connection, CommandType.Text);

			if (queryDefinition.TableName.Length == 0)
			{
				queryDefinition.TableName = "gvwSuppliers";
			}

			queryDefinition.BuildCommand(CommandSelect);

			return OpenReader();
		}
		
		
		/// <summary>
		/// Selects rows from the Suppliers table by Primary Key (SupplierID)
		/// </summary>
		/// <param name="SupplierID">The SupplierID to use as search criteria</param>
		/// <returns>true on success, false otherwise</returns>
		public bool SelectBySupplierID(Int32 SupplierID)
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();
		
			CommandSelect = DataObjectFactory.CreateCommand(Connection, CommandType.StoredProcedure);
			CommandSelect.CommandText = "gspSuppliers_SelectBySupplierID";
			
			CommandSelect.Parameters.Add(DataObjectFactory.CreateCommandParameter("@SupplierID", SqlDbType.Int, SupplierID));
			
			return OpenReader();
		}
		
		/// <summary>
		/// Checks if the value of the ContactName column is NULL
		/// </summary>
		/// <returns>true if ContactName is NULL, false if it is not NULL</returns>
		public bool IsContactNameNull()
		{
			return DataRecord.IsDBNull(m_ContactNameOrdinal);
		}
		
		/// <summary>
		/// Checks if the value of the ContactTitle column is NULL
		/// </summary>
		/// <returns>true if ContactTitle is NULL, false if it is not NULL</returns>
		public bool IsContactTitleNull()
		{
			return DataRecord.IsDBNull(m_ContactTitleOrdinal);
		}
		
		/// <summary>
		/// Checks if the value of the Address column is NULL
		/// </summary>
		/// <returns>true if Address is NULL, false if it is not NULL</returns>
		public bool IsAddressNull()
		{
			return DataRecord.IsDBNull(m_AddressOrdinal);
		}
		
		/// <summary>
		/// Checks if the value of the City column is NULL
		/// </summary>
		/// <returns>true if City is NULL, false if it is not NULL</returns>
		public bool IsCityNull()
		{
			return DataRecord.IsDBNull(m_CityOrdinal);
		}
		
		/// <summary>
		/// Checks if the value of the Region column is NULL
		/// </summary>
		/// <returns>true if Region is NULL, false if it is not NULL</returns>
		public bool IsRegionNull()
		{
			return DataRecord.IsDBNull(m_RegionOrdinal);
		}
		
		/// <summary>
		/// Checks if the value of the PostalCode column is NULL
		/// </summary>
		/// <returns>true if PostalCode is NULL, false if it is not NULL</returns>
		public bool IsPostalCodeNull()
		{
			return DataRecord.IsDBNull(m_PostalCodeOrdinal);
		}
		
		/// <summary>
		/// Checks if the value of the Country column is NULL
		/// </summary>
		/// <returns>true if Country is NULL, false if it is not NULL</returns>
		public bool IsCountryNull()
		{
			return DataRecord.IsDBNull(m_CountryOrdinal);
		}
		
		/// <summary>
		/// Checks if the value of the Phone column is NULL
		/// </summary>
		/// <returns>true if Phone is NULL, false if it is not NULL</returns>
		public bool IsPhoneNull()
		{
			return DataRecord.IsDBNull(m_PhoneOrdinal);
		}
		
		/// <summary>
		/// Checks if the value of the Fax column is NULL
		/// </summary>
		/// <returns>true if Fax is NULL, false if it is not NULL</returns>
		public bool IsFaxNull()
		{
			return DataRecord.IsDBNull(m_FaxOrdinal);
		}
		
		/// <summary>
		/// Checks if the value of the HomePage column is NULL
		/// </summary>
		/// <returns>true if HomePage is NULL, false if it is not NULL</returns>
		public bool IsHomePageNull()
		{
			return DataRecord.IsDBNull(m_HomePageOrdinal);
		}
		
		
		
		
		#endregion
	}
}
