using System;
using System.Data;
using System.Data.OleDb;
using System.Data.SqlClient;
using System.Collections;

using RAD.AppFramework.Data;
using RAD.AppFramework.QueryObjects;

using NorthwindSample.Common;
using NorthwindSample.DataAccess;

namespace NorthwindSample.DataAccess.Readers.Base
{
	/// <summary>
	/// Base class for the TerritoriesDataReader
	/// <seealso cref="TerritoriesDataReader"/>
	/// </summary>
	/// <remarks>
	/// Provides forward-only read access to the Territories table.
	/// 
	/// This class has been auto-generated and should not be modified. Any modifications should
	/// be made to the <see cref="TerritoriesDataReader">TerritoriesDataReader</see> class.
	/// <br/><br/>
	/// This class was automatically generated by Rad Software NextGeneration <a href="http://www.radsoftware.com.au">http://www.radsoftware.com.au</a>
	/// </remarks>
	public class TerritoriesDataReaderBase : StronglyTypedDataReader
	{		
		#region Fields
	
		/// <summary>The ordinal position of the TerritoryID column in the result set</summary>
		protected int m_TerritoryIDOrdinal;
		/// <summary>The ordinal position of the TerritoryDescription column in the result set</summary>
		protected int m_TerritoryDescriptionOrdinal;
		/// <summary>The ordinal position of the RegionID column in the result set</summary>
		protected int m_RegionIDOrdinal;
			
		#endregion
		
		
		#region Constructors
		
		/// <summary>
		/// Creates a new TerritoriesDataReaderBase
		/// </summary>
		public TerritoriesDataReaderBase()
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();
		
			Connection = DataObjectFactory.CreateConnection();
		}
		
		#endregion
		

		#region Column Attributes


		/// <summary>
		/// Returns the value of the TerritoryID column for the current row
		/// </summary>
		public String TerritoryID
		{
			get 
			{
					return (String)DataRecord[m_TerritoryIDOrdinal];
			}
		}
	
		/// <summary>
		/// Returns the value of the TerritoryDescription column for the current row
		/// </summary>
		public String TerritoryDescription
		{
			get 
			{
					return (String)DataRecord[m_TerritoryDescriptionOrdinal];
			}
		}
	
		/// <summary>
		/// Returns the value of the RegionID column for the current row
		/// </summary>
		public Int32 RegionID
		{
			get 
			{
					return (Int32)DataRecord[m_RegionIDOrdinal];
			}
		}
	

		#endregion

		
		#region Private Methods
		
		/// <summary>
		/// Sets the indexes of the columns within the result set
		/// </summary>
		protected override void SetColumnOrdinals()
		{
			m_TerritoryIDOrdinal = DataReader.GetOrdinal("TerritoryID");
			m_TerritoryDescriptionOrdinal = DataReader.GetOrdinal("TerritoryDescription");
			m_RegionIDOrdinal = DataReader.GetOrdinal("RegionID");
		}
		
		#endregion
		
		
		#region Public Methods
		
		/// <summary>
		/// Selects all rows from the Territories table
		/// </summary>
		/// <returns>true on success, false otherwise</returns>
		public bool SelectAll()
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();
		
			CommandSelect = DataObjectFactory.CreateCommand(Connection, CommandType.StoredProcedure);
			CommandSelect.CommandText = "gspTerritories_SelectAll";
			
			return OpenReader();
		}
		
		/// <summary>
		/// Selects rows from the Territories table by Query definion
		/// </summary>
		/// <param name="queryDefinition">A Query object that defines the Query used to select rows from the database</param>
		/// <returns>true on success, false otherwise</returns>
		public bool SelectByQuery(Query queryDefinition)
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();

			CommandSelect = DataObjectFactory.CreateCommand(Connection, CommandType.Text);

			if (queryDefinition.TableName.Length == 0)
			{
				queryDefinition.TableName = "gvwTerritories";
			}

			queryDefinition.BuildCommand(CommandSelect);

			return OpenReader();
		}
		
		
		/// <summary>
		/// Selects rows from the Territories table by Primary Key (TerritoryID)
		/// </summary>
		/// <param name="TerritoryID">The TerritoryID to use as search criteria</param>
		/// <returns>true on success, false otherwise</returns>
		public bool SelectByTerritoryID(String TerritoryID)
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();
		
			CommandSelect = DataObjectFactory.CreateCommand(Connection, CommandType.StoredProcedure);
			CommandSelect.CommandText = "gspTerritories_SelectByTerritoryID";
			
			CommandSelect.Parameters.Add(DataObjectFactory.CreateCommandParameter("@TerritoryID", SqlDbType.NVarChar, 20, TerritoryID));
			
			return OpenReader();
		}
		
		/// <summary>
		/// Selects rows from the Territories table by RegionID
		/// </summary>
		/// <param name="RegionID">The RegionID to use as search criteria</param>
		/// <returns>true on success, false otherwise</returns>
		public bool SelectByRegionID(Int32 RegionID)
		{
			DatabaseAccessObjectFactory DataObjectFactory = CommonFactory.CreateDataObjectFactory();
		
			CommandSelect = DataObjectFactory.CreateCommand(Connection, CommandType.StoredProcedure);
			CommandSelect.CommandText = "gspTerritories_SelectByRegionID";
			
			CommandSelect.Parameters.Add(DataObjectFactory.CreateCommandParameter("@RegionID", SqlDbType.Int, RegionID));
			
			return OpenReader();
		}
		
		
		
		
		#endregion
	}
}
