/*
** 010_ViewsForStoredProcedures.sql
**
** Drop and re-create the views that are used by
** the select stored procedures 
**
** This script was automatically generated by
** Rad Software NextGeneration
**
** http://www.radsoftware.com.au/
**
*/

/*
** Connect to the NorthwindSample database
*/
USE [NorthwindSample]
GO

	
/*
** Drop gvwCategories
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gvwCategories'))
BEGIN
	PRINT 'gvwCategories dropped'
	DROP VIEW gvwCategories
END	
GO
	
/*
** Drop gvwCustomerCustomerDemo
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gvwCustomerCustomerDemo'))
BEGIN
	PRINT 'gvwCustomerCustomerDemo dropped'
	DROP VIEW gvwCustomerCustomerDemo
END	
GO
	
/*
** Drop gvwCustomerDemographics
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gvwCustomerDemographics'))
BEGIN
	PRINT 'gvwCustomerDemographics dropped'
	DROP VIEW gvwCustomerDemographics
END	
GO
	
/*
** Drop gvwCustomers
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gvwCustomers'))
BEGIN
	PRINT 'gvwCustomers dropped'
	DROP VIEW gvwCustomers
END	
GO
	
/*
** Drop gvwEmployees
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gvwEmployees'))
BEGIN
	PRINT 'gvwEmployees dropped'
	DROP VIEW gvwEmployees
END	
GO
	
/*
** Drop gvwEmployeeTerritories
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gvwEmployeeTerritories'))
BEGIN
	PRINT 'gvwEmployeeTerritories dropped'
	DROP VIEW gvwEmployeeTerritories
END	
GO
	
/*
** Drop gvwOrderDetails
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gvwOrderDetails'))
BEGIN
	PRINT 'gvwOrderDetails dropped'
	DROP VIEW gvwOrderDetails
END	
GO
	
/*
** Drop gvwOrders
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gvwOrders'))
BEGIN
	PRINT 'gvwOrders dropped'
	DROP VIEW gvwOrders
END	
GO
	
/*
** Drop gvwProducts
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gvwProducts'))
BEGIN
	PRINT 'gvwProducts dropped'
	DROP VIEW gvwProducts
END	
GO
	
/*
** Drop gvwRegion
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gvwRegion'))
BEGIN
	PRINT 'gvwRegion dropped'
	DROP VIEW gvwRegion
END	
GO
	
/*
** Drop gvwShippers
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gvwShippers'))
BEGIN
	PRINT 'gvwShippers dropped'
	DROP VIEW gvwShippers
END	
GO
	
/*
** Drop gvwSuppliers
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gvwSuppliers'))
BEGIN
	PRINT 'gvwSuppliers dropped'
	DROP VIEW gvwSuppliers
END	
GO
	
/*
** Drop gvwTerritories
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gvwTerritories'))
BEGIN
	PRINT 'gvwTerritories dropped'
	DROP VIEW gvwTerritories
END	
GO
	
/*
**
** Create the views used by the 
** select stored procedures 
**
**
*/

/*
** gvwCategories
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE VIEW gvwCategories
AS
/*
** Select all rows from the Categories table
** and the lookup expressions defined for associated tables
*/

SELECT 
	[Categories].*
FROM
	[Categories]


GO
PRINT 'gvwCategories created'
GO

GRANT SELECT ON [gvwCategories] TO public
GO


/*
** gvwCustomerCustomerDemo
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE VIEW gvwCustomerCustomerDemo
AS
/*
** Select all rows from the CustomerCustomerDemo table
** and the lookup expressions defined for associated tables
*/

SELECT 
	[CustomerCustomerDemo].*
FROM
	[CustomerCustomerDemo]


GO
PRINT 'gvwCustomerCustomerDemo created'
GO

GRANT SELECT ON [gvwCustomerCustomerDemo] TO public
GO


/*
** gvwCustomerDemographics
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE VIEW gvwCustomerDemographics
AS
/*
** Select all rows from the CustomerDemographics table
** and the lookup expressions defined for associated tables
*/

SELECT 
	[CustomerDemographics].*
FROM
	[CustomerDemographics]


GO
PRINT 'gvwCustomerDemographics created'
GO

GRANT SELECT ON [gvwCustomerDemographics] TO public
GO


/*
** gvwCustomers
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE VIEW gvwCustomers
AS
/*
** Select all rows from the Customers table
** and the lookup expressions defined for associated tables
*/

SELECT 
	[Customers].*
FROM
	[Customers]


GO
PRINT 'gvwCustomers created'
GO

GRANT SELECT ON [gvwCustomers] TO public
GO


/*
** gvwEmployees
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE VIEW gvwEmployees
AS
/*
** Select all rows from the Employees table
** and the lookup expressions defined for associated tables
*/

SELECT 
	[Employees].*
FROM
	[Employees]


GO
PRINT 'gvwEmployees created'
GO

GRANT SELECT ON [gvwEmployees] TO public
GO


/*
** gvwEmployeeTerritories
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE VIEW gvwEmployeeTerritories
AS
/*
** Select all rows from the EmployeeTerritories table
** and the lookup expressions defined for associated tables
*/

SELECT 
	[EmployeeTerritories].*
FROM
	[EmployeeTerritories]


GO
PRINT 'gvwEmployeeTerritories created'
GO

GRANT SELECT ON [gvwEmployeeTerritories] TO public
GO


/*
** gvwOrderDetails
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE VIEW gvwOrderDetails
AS
/*
** Select all rows from the Order Details table
** and the lookup expressions defined for associated tables
*/

SELECT 
	[Order Details].*
FROM
	[Order Details]


GO
PRINT 'gvwOrderDetails created'
GO

GRANT SELECT ON [gvwOrderDetails] TO public
GO


/*
** gvwOrders
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE VIEW gvwOrders
AS
/*
** Select all rows from the Orders table
** and the lookup expressions defined for associated tables
*/

SELECT 
	[Orders].*
FROM
	[Orders]


GO
PRINT 'gvwOrders created'
GO

GRANT SELECT ON [gvwOrders] TO public
GO


/*
** gvwProducts
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE VIEW gvwProducts
AS
/*
** Select all rows from the Products table
** and the lookup expressions defined for associated tables
*/

SELECT 
	[Products].*
FROM
	[Products]


GO
PRINT 'gvwProducts created'
GO

GRANT SELECT ON [gvwProducts] TO public
GO


/*
** gvwRegion
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE VIEW gvwRegion
AS
/*
** Select all rows from the Region table
** and the lookup expressions defined for associated tables
*/

SELECT 
	[Region].*
FROM
	[Region]


GO
PRINT 'gvwRegion created'
GO

GRANT SELECT ON [gvwRegion] TO public
GO


/*
** gvwShippers
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE VIEW gvwShippers
AS
/*
** Select all rows from the Shippers table
** and the lookup expressions defined for associated tables
*/

SELECT 
	[Shippers].*
FROM
	[Shippers]


GO
PRINT 'gvwShippers created'
GO

GRANT SELECT ON [gvwShippers] TO public
GO


/*
** gvwSuppliers
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE VIEW gvwSuppliers
AS
/*
** Select all rows from the Suppliers table
** and the lookup expressions defined for associated tables
*/

SELECT 
	[Suppliers].*
FROM
	[Suppliers]


GO
PRINT 'gvwSuppliers created'
GO

GRANT SELECT ON [gvwSuppliers] TO public
GO


/*
** gvwTerritories
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE VIEW gvwTerritories
AS
/*
** Select all rows from the Territories table
** and the lookup expressions defined for associated tables
*/

SELECT 
	[Territories].*
FROM
	[Territories]


GO
PRINT 'gvwTerritories created'
GO

GRANT SELECT ON [gvwTerritories] TO public
GO
