/*
** 030_StoredProcedures_Insert.sql
**
** Drop and re-create the stored procedures used 
** when adding new rows to the database
**
** This script was automatically generated by
** Rad Software NextGeneration
**
** http://www.radsoftware.com.au/
**
*/

/*
** Connect to the NorthwindSample database
*/
USE [NorthwindSample]
GO

	
/*
** Drop gspCategories_Insert
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gspCategories_Insert'))
BEGIN
	PRINT 'gspCategories_Insert dropped'
	DROP PROCEDURE gspCategories_Insert
END	
GO
	
/*
** Drop gspCustomerCustomerDemo_Insert
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gspCustomerCustomerDemo_Insert'))
BEGIN
	PRINT 'gspCustomerCustomerDemo_Insert dropped'
	DROP PROCEDURE gspCustomerCustomerDemo_Insert
END	
GO
	
/*
** Drop gspCustomerDemographics_Insert
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gspCustomerDemographics_Insert'))
BEGIN
	PRINT 'gspCustomerDemographics_Insert dropped'
	DROP PROCEDURE gspCustomerDemographics_Insert
END	
GO
	
/*
** Drop gspCustomers_Insert
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gspCustomers_Insert'))
BEGIN
	PRINT 'gspCustomers_Insert dropped'
	DROP PROCEDURE gspCustomers_Insert
END	
GO
	
/*
** Drop gspEmployees_Insert
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gspEmployees_Insert'))
BEGIN
	PRINT 'gspEmployees_Insert dropped'
	DROP PROCEDURE gspEmployees_Insert
END	
GO
	
/*
** Drop gspEmployeeTerritories_Insert
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gspEmployeeTerritories_Insert'))
BEGIN
	PRINT 'gspEmployeeTerritories_Insert dropped'
	DROP PROCEDURE gspEmployeeTerritories_Insert
END	
GO
	
/*
** Drop gspOrderDetails_Insert
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gspOrderDetails_Insert'))
BEGIN
	PRINT 'gspOrderDetails_Insert dropped'
	DROP PROCEDURE gspOrderDetails_Insert
END	
GO
	
/*
** Drop gspOrders_Insert
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gspOrders_Insert'))
BEGIN
	PRINT 'gspOrders_Insert dropped'
	DROP PROCEDURE gspOrders_Insert
END	
GO
	
/*
** Drop gspProducts_Insert
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gspProducts_Insert'))
BEGIN
	PRINT 'gspProducts_Insert dropped'
	DROP PROCEDURE gspProducts_Insert
END	
GO
	
/*
** Drop gspRegion_Insert
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gspRegion_Insert'))
BEGIN
	PRINT 'gspRegion_Insert dropped'
	DROP PROCEDURE gspRegion_Insert
END	
GO
	
/*
** Drop gspShippers_Insert
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gspShippers_Insert'))
BEGIN
	PRINT 'gspShippers_Insert dropped'
	DROP PROCEDURE gspShippers_Insert
END	
GO
	
/*
** Drop gspSuppliers_Insert
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gspSuppliers_Insert'))
BEGIN
	PRINT 'gspSuppliers_Insert dropped'
	DROP PROCEDURE gspSuppliers_Insert
END	
GO
	
/*
** Drop gspTerritories_Insert
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gspTerritories_Insert'))
BEGIN
	PRINT 'gspTerritories_Insert dropped'
	DROP PROCEDURE gspTerritories_Insert
END	
GO
	
/*
** Drop gspViewOrderDetails_Insert
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gspViewOrderDetails_Insert'))
BEGIN
	PRINT 'gspViewOrderDetails_Insert dropped'
	DROP PROCEDURE gspViewOrderDetails_Insert
END	
GO
	
/*
**
** Create the stored procedures used 
** when adding new rows to the database
**
**
*/

/*
** gspCategories_Insert
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE gspCategories_Insert
(
	@CategoryID int OUTPUT, -- the automatically generated value will be returned as an output parameter
	@CategoryName nvarchar(15),
	@Description ntext,
	@Picture image
)
AS
/*
** Add a row to the Categories table
*/

INSERT INTO [Categories]
(
	 [CategoryName]
	,[Description]
	,[Picture]
)
VALUES
(
	 @CategoryName
	,@Description
	,@Picture
)

SET @CategoryID = (SELECT SCOPE_IDENTITY())

/*
** Select the new row
*/
SELECT
	gvwCategories.*
FROM
	gvwCategories
WHERE
	[CategoryID] = @CategoryID

GO
PRINT 'gspCategories_Insert created'
GO


GRANT EXECUTE ON [gspCategories_Insert] TO public
GO

/*
** gspCustomerCustomerDemo_Insert
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE gspCustomerCustomerDemo_Insert
(
	@CustomerID nchar(5),
	@CustomerTypeID nchar(10)
)
AS
/*
** Add a row to the CustomerCustomerDemo table
*/

INSERT INTO [CustomerCustomerDemo]
(
	 [CustomerID]
	,[CustomerTypeID]
)
VALUES
(
	 @CustomerID
	,@CustomerTypeID
)

/*
** Select the new row
*/
SELECT
	gvwCustomerCustomerDemo.*
FROM
	gvwCustomerCustomerDemo
WHERE
	[CustomerID] = @CustomerID
	AND [CustomerTypeID] = @CustomerTypeID

GO
PRINT 'gspCustomerCustomerDemo_Insert created'
GO


GRANT EXECUTE ON [gspCustomerCustomerDemo_Insert] TO public
GO

/*
** gspCustomerDemographics_Insert
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE gspCustomerDemographics_Insert
(
	@CustomerTypeID nchar(10),
	@CustomerDesc ntext
)
AS
/*
** Add a row to the CustomerDemographics table
*/

INSERT INTO [CustomerDemographics]
(
	 [CustomerTypeID]
	,[CustomerDesc]
)
VALUES
(
	 @CustomerTypeID
	,@CustomerDesc
)

/*
** Select the new row
*/
SELECT
	gvwCustomerDemographics.*
FROM
	gvwCustomerDemographics
WHERE
	[CustomerTypeID] = @CustomerTypeID

GO
PRINT 'gspCustomerDemographics_Insert created'
GO


GRANT EXECUTE ON [gspCustomerDemographics_Insert] TO public
GO

/*
** gspCustomers_Insert
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE gspCustomers_Insert
(
	@CustomerID nchar(5),
	@CompanyName nvarchar(40),
	@ContactName nvarchar(30),
	@ContactTitle nvarchar(30),
	@Address nvarchar(60),
	@City nvarchar(15),
	@Region nvarchar(15),
	@PostalCode nvarchar(10),
	@Country nvarchar(15),
	@Phone nvarchar(24),
	@Fax nvarchar(24)
)
AS
/*
** Add a row to the Customers table
*/

INSERT INTO [Customers]
(
	 [CustomerID]
	,[CompanyName]
	,[ContactName]
	,[ContactTitle]
	,[Address]
	,[City]
	,[Region]
	,[PostalCode]
	,[Country]
	,[Phone]
	,[Fax]
)
VALUES
(
	 @CustomerID
	,@CompanyName
	,@ContactName
	,@ContactTitle
	,@Address
	,@City
	,@Region
	,@PostalCode
	,@Country
	,@Phone
	,@Fax
)

/*
** Select the new row
*/
SELECT
	gvwCustomers.*
FROM
	gvwCustomers
WHERE
	[CustomerID] = @CustomerID

GO
PRINT 'gspCustomers_Insert created'
GO


GRANT EXECUTE ON [gspCustomers_Insert] TO public
GO

/*
** gspEmployees_Insert
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE gspEmployees_Insert
(
	@EmployeeID int OUTPUT, -- the automatically generated value will be returned as an output parameter
	@LastName nvarchar(20),
	@FirstName nvarchar(10),
	@Title nvarchar(30),
	@TitleOfCourtesy nvarchar(25),
	@BirthDate datetime,
	@HireDate datetime,
	@Address nvarchar(60),
	@City nvarchar(15),
	@Region nvarchar(15),
	@PostalCode nvarchar(10),
	@Country nvarchar(15),
	@HomePhone nvarchar(24),
	@Extension nvarchar(4),
	@Photo image,
	@Notes ntext,
	@ReportsTo int,
	@PhotoPath nvarchar(255)
)
AS
/*
** Add a row to the Employees table
*/

INSERT INTO [Employees]
(
	 [LastName]
	,[FirstName]
	,[Title]
	,[TitleOfCourtesy]
	,[BirthDate]
	,[HireDate]
	,[Address]
	,[City]
	,[Region]
	,[PostalCode]
	,[Country]
	,[HomePhone]
	,[Extension]
	,[Photo]
	,[Notes]
	,[ReportsTo]
	,[PhotoPath]
)
VALUES
(
	 @LastName
	,@FirstName
	,@Title
	,@TitleOfCourtesy
	,@BirthDate
	,@HireDate
	,@Address
	,@City
	,@Region
	,@PostalCode
	,@Country
	,@HomePhone
	,@Extension
	,@Photo
	,@Notes
	,@ReportsTo
	,@PhotoPath
)

SET @EmployeeID = (SELECT SCOPE_IDENTITY())

/*
** Select the new row
*/
SELECT
	gvwEmployees.*
FROM
	gvwEmployees
WHERE
	[EmployeeID] = @EmployeeID

GO
PRINT 'gspEmployees_Insert created'
GO


GRANT EXECUTE ON [gspEmployees_Insert] TO public
GO

/*
** gspEmployeeTerritories_Insert
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE gspEmployeeTerritories_Insert
(
	@EmployeeID int,
	@TerritoryID nvarchar(20)
)
AS
/*
** Add a row to the EmployeeTerritories table
*/

INSERT INTO [EmployeeTerritories]
(
	 [EmployeeID]
	,[TerritoryID]
)
VALUES
(
	 @EmployeeID
	,@TerritoryID
)

/*
** Select the new row
*/
SELECT
	gvwEmployeeTerritories.*
FROM
	gvwEmployeeTerritories
WHERE
	[EmployeeID] = @EmployeeID
	AND [TerritoryID] = @TerritoryID

GO
PRINT 'gspEmployeeTerritories_Insert created'
GO


GRANT EXECUTE ON [gspEmployeeTerritories_Insert] TO public
GO

/*
** gspOrderDetails_Insert
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE gspOrderDetails_Insert
(
	@OrderID int,
	@ProductID int,
	@UnitPrice money,
	@Quantity smallint,
	@Discount real
)
AS
/*
** Add a row to the Order Details table
*/

INSERT INTO [Order Details]
(
	 [OrderID]
	,[ProductID]
	,[UnitPrice]
	,[Quantity]
	,[Discount]
)
VALUES
(
	 @OrderID
	,@ProductID
	,@UnitPrice
	,@Quantity
	,@Discount
)

/*
** Select the new row
*/
SELECT
	gvwOrderDetails.*
FROM
	gvwOrderDetails
WHERE
	[OrderID] = @OrderID
	AND [ProductID] = @ProductID

GO
PRINT 'gspOrderDetails_Insert created'
GO


GRANT EXECUTE ON [gspOrderDetails_Insert] TO public
GO

/*
** gspOrders_Insert
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE gspOrders_Insert
(
	@OrderID int OUTPUT, -- the automatically generated value will be returned as an output parameter
	@CustomerID nchar(5),
	@EmployeeID int,
	@OrderDate datetime,
	@RequiredDate datetime,
	@ShippedDate datetime,
	@ShipVia int,
	@Freight money,
	@ShipName nvarchar(40),
	@ShipAddress nvarchar(60),
	@ShipCity nvarchar(15),
	@ShipRegion nvarchar(15),
	@ShipPostalCode nvarchar(10),
	@ShipCountry nvarchar(15)
)
AS
/*
** Add a row to the Orders table
*/

INSERT INTO [Orders]
(
	 [CustomerID]
	,[EmployeeID]
	,[OrderDate]
	,[RequiredDate]
	,[ShippedDate]
	,[ShipVia]
	,[Freight]
	,[ShipName]
	,[ShipAddress]
	,[ShipCity]
	,[ShipRegion]
	,[ShipPostalCode]
	,[ShipCountry]
)
VALUES
(
	 @CustomerID
	,@EmployeeID
	,@OrderDate
	,@RequiredDate
	,@ShippedDate
	,@ShipVia
	,@Freight
	,@ShipName
	,@ShipAddress
	,@ShipCity
	,@ShipRegion
	,@ShipPostalCode
	,@ShipCountry
)

SET @OrderID = (SELECT SCOPE_IDENTITY())

/*
** Select the new row
*/
SELECT
	gvwOrders.*
FROM
	gvwOrders
WHERE
	[OrderID] = @OrderID

GO
PRINT 'gspOrders_Insert created'
GO


GRANT EXECUTE ON [gspOrders_Insert] TO public
GO

/*
** gspProducts_Insert
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE gspProducts_Insert
(
	@ProductID int OUTPUT, -- the automatically generated value will be returned as an output parameter
	@ProductName nvarchar(40),
	@SupplierID int,
	@CategoryID int,
	@QuantityPerUnit nvarchar(20),
	@UnitPrice money,
	@UnitsInStock smallint,
	@UnitsOnOrder smallint,
	@ReorderLevel smallint,
	@Discontinued bit
)
AS
/*
** Add a row to the Products table
*/

INSERT INTO [Products]
(
	 [ProductName]
	,[SupplierID]
	,[CategoryID]
	,[QuantityPerUnit]
	,[UnitPrice]
	,[UnitsInStock]
	,[UnitsOnOrder]
	,[ReorderLevel]
	,[Discontinued]
)
VALUES
(
	 @ProductName
	,@SupplierID
	,@CategoryID
	,@QuantityPerUnit
	,@UnitPrice
	,@UnitsInStock
	,@UnitsOnOrder
	,@ReorderLevel
	,@Discontinued
)

SET @ProductID = (SELECT SCOPE_IDENTITY())

/*
** Select the new row
*/
SELECT
	gvwProducts.*
FROM
	gvwProducts
WHERE
	[ProductID] = @ProductID

GO
PRINT 'gspProducts_Insert created'
GO


GRANT EXECUTE ON [gspProducts_Insert] TO public
GO

/*
** gspRegion_Insert
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE gspRegion_Insert
(
	@RegionID int,
	@RegionDescription nchar(50)
)
AS
/*
** Add a row to the Region table
*/

INSERT INTO [Region]
(
	 [RegionID]
	,[RegionDescription]
)
VALUES
(
	 @RegionID
	,@RegionDescription
)

/*
** Select the new row
*/
SELECT
	gvwRegion.*
FROM
	gvwRegion
WHERE
	[RegionID] = @RegionID

GO
PRINT 'gspRegion_Insert created'
GO


GRANT EXECUTE ON [gspRegion_Insert] TO public
GO

/*
** gspShippers_Insert
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE gspShippers_Insert
(
	@ShipperID int OUTPUT, -- the automatically generated value will be returned as an output parameter
	@CompanyName nvarchar(40),
	@Phone nvarchar(24)
)
AS
/*
** Add a row to the Shippers table
*/

INSERT INTO [Shippers]
(
	 [CompanyName]
	,[Phone]
)
VALUES
(
	 @CompanyName
	,@Phone
)

SET @ShipperID = (SELECT SCOPE_IDENTITY())

/*
** Select the new row
*/
SELECT
	gvwShippers.*
FROM
	gvwShippers
WHERE
	[ShipperID] = @ShipperID

GO
PRINT 'gspShippers_Insert created'
GO


GRANT EXECUTE ON [gspShippers_Insert] TO public
GO

/*
** gspSuppliers_Insert
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE gspSuppliers_Insert
(
	@SupplierID int OUTPUT, -- the automatically generated value will be returned as an output parameter
	@CompanyName nvarchar(40),
	@ContactName nvarchar(30),
	@ContactTitle nvarchar(30),
	@Address nvarchar(60),
	@City nvarchar(15),
	@Region nvarchar(15),
	@PostalCode nvarchar(10),
	@Country nvarchar(15),
	@Phone nvarchar(24),
	@Fax nvarchar(24),
	@HomePage ntext
)
AS
/*
** Add a row to the Suppliers table
*/

INSERT INTO [Suppliers]
(
	 [CompanyName]
	,[ContactName]
	,[ContactTitle]
	,[Address]
	,[City]
	,[Region]
	,[PostalCode]
	,[Country]
	,[Phone]
	,[Fax]
	,[HomePage]
)
VALUES
(
	 @CompanyName
	,@ContactName
	,@ContactTitle
	,@Address
	,@City
	,@Region
	,@PostalCode
	,@Country
	,@Phone
	,@Fax
	,@HomePage
)

SET @SupplierID = (SELECT SCOPE_IDENTITY())

/*
** Select the new row
*/
SELECT
	gvwSuppliers.*
FROM
	gvwSuppliers
WHERE
	[SupplierID] = @SupplierID

GO
PRINT 'gspSuppliers_Insert created'
GO


GRANT EXECUTE ON [gspSuppliers_Insert] TO public
GO

/*
** gspTerritories_Insert
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE gspTerritories_Insert
(
	@TerritoryID nvarchar(20),
	@TerritoryDescription nchar(50),
	@RegionID int
)
AS
/*
** Add a row to the Territories table
*/

INSERT INTO [Territories]
(
	 [TerritoryID]
	,[TerritoryDescription]
	,[RegionID]
)
VALUES
(
	 @TerritoryID
	,@TerritoryDescription
	,@RegionID
)

/*
** Select the new row
*/
SELECT
	gvwTerritories.*
FROM
	gvwTerritories
WHERE
	[TerritoryID] = @TerritoryID

GO
PRINT 'gspTerritories_Insert created'
GO


GRANT EXECUTE ON [gspTerritories_Insert] TO public
GO

/*
** gspViewOrderDetails_Insert
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE gspViewOrderDetails_Insert
(
	@OrderID int,
	@ProductID int,
	@ProductName nvarchar(40),
	@UnitPrice money,
	@Quantity smallint,
	@Discount real
)
AS
/*
** Add a row to the ViewOrderDetails table
*/

INSERT INTO [ViewOrderDetails]
(
	 [OrderID]
	,[ProductID]
	,[ProductName]
	,[UnitPrice]
	,[Quantity]
	,[Discount]
)
VALUES
(
	 @OrderID
	,@ProductID
	,@ProductName
	,@UnitPrice
	,@Quantity
	,@Discount
)

/*
** Select the new row
*/
SELECT
	[ViewOrderDetails].*
FROM
	[ViewOrderDetails]

GO
PRINT 'gspViewOrderDetails_Insert created'
GO


GRANT EXECUTE ON [gspViewOrderDetails_Insert] TO public
GO
