/*
** 040_StoredProcedures_Update.sql
**
** Drop and re-create the stored procedures used 
** when updating existing rows in the database
**
** This script was automatically generated by
** Rad Software NextGeneration
**
** http://www.radsoftware.com.au/
**
*/

/*
** Connect to the NorthwindSample database
*/
USE [NorthwindSample]
GO

	
/*
** Drop gspCategories_Update
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gspCategories_Update'))
BEGIN
	PRINT 'gspCategories_Update dropped'
	DROP PROCEDURE gspCategories_Update
END	
GO

/*
** Drop gspCustomerCustomerDemo_Update
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gspCustomerCustomerDemo_Update'))
BEGIN
	PRINT 'gspCustomerCustomerDemo_Update dropped'
	DROP PROCEDURE gspCustomerCustomerDemo_Update
END	
GO

/*
** Drop gspCustomerDemographics_Update
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gspCustomerDemographics_Update'))
BEGIN
	PRINT 'gspCustomerDemographics_Update dropped'
	DROP PROCEDURE gspCustomerDemographics_Update
END	
GO

/*
** Drop gspCustomers_Update
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gspCustomers_Update'))
BEGIN
	PRINT 'gspCustomers_Update dropped'
	DROP PROCEDURE gspCustomers_Update
END	
GO

/*
** Drop gspEmployees_Update
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gspEmployees_Update'))
BEGIN
	PRINT 'gspEmployees_Update dropped'
	DROP PROCEDURE gspEmployees_Update
END	
GO

/*
** Drop gspEmployeeTerritories_Update
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gspEmployeeTerritories_Update'))
BEGIN
	PRINT 'gspEmployeeTerritories_Update dropped'
	DROP PROCEDURE gspEmployeeTerritories_Update
END	
GO

/*
** Drop gspOrderDetails_Update
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gspOrderDetails_Update'))
BEGIN
	PRINT 'gspOrderDetails_Update dropped'
	DROP PROCEDURE gspOrderDetails_Update
END	
GO

/*
** Drop gspOrders_Update
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gspOrders_Update'))
BEGIN
	PRINT 'gspOrders_Update dropped'
	DROP PROCEDURE gspOrders_Update
END	
GO

/*
** Drop gspProducts_Update
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gspProducts_Update'))
BEGIN
	PRINT 'gspProducts_Update dropped'
	DROP PROCEDURE gspProducts_Update
END	
GO

/*
** Drop gspRegion_Update
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gspRegion_Update'))
BEGIN
	PRINT 'gspRegion_Update dropped'
	DROP PROCEDURE gspRegion_Update
END	
GO

/*
** Drop gspShippers_Update
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gspShippers_Update'))
BEGIN
	PRINT 'gspShippers_Update dropped'
	DROP PROCEDURE gspShippers_Update
END	
GO

/*
** Drop gspSuppliers_Update
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gspSuppliers_Update'))
BEGIN
	PRINT 'gspSuppliers_Update dropped'
	DROP PROCEDURE gspSuppliers_Update
END	
GO

/*
** Drop gspTerritories_Update
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gspTerritories_Update'))
BEGIN
	PRINT 'gspTerritories_Update dropped'
	DROP PROCEDURE gspTerritories_Update
END	
GO

/*
**
** Create the stored procedures used 
** when updating existing rows in the database
**
**
*/

/*
** gspCategories_Update
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE gspCategories_Update
(
	@CategoryIDOriginal int, 
	@CategoryID int,
	@CategoryName nvarchar(15),
	@Description ntext,
	@Picture image
)
AS
/*
** Update a row in the Categories table using the primary key
*/

UPDATE 
	[Categories]
SET 
	[CategoryName] = @CategoryName
	,[Description] = @Description
	,[Picture] = @Picture
WHERE
	[CategoryID] = @CategoryIDOriginal


/*
** Select the updated row
*/
SELECT
	gvwCategories.*
FROM
	gvwCategories
WHERE
	[CategoryID] = @CategoryID


GO
PRINT 'gspCategories_Update created'
GO


GRANT EXECUTE ON [gspCategories_Update] TO public
GO

/*
** gspCustomerCustomerDemo_Update
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE gspCustomerCustomerDemo_Update
(
	@CustomerIDOriginal nchar(5), 
	@CustomerID nchar(5),
	@CustomerTypeIDOriginal nchar(10), 
	@CustomerTypeID nchar(10)
)
AS
/*
** Update a row in the CustomerCustomerDemo table using the primary key
*/

UPDATE 
	[CustomerCustomerDemo]
SET 
	[CustomerID] = @CustomerID
	,[CustomerTypeID] = @CustomerTypeID
WHERE
	[CustomerID] = @CustomerIDOriginal
	AND [CustomerTypeID] = @CustomerTypeIDOriginal


/*
** Select the updated row
*/
SELECT
	gvwCustomerCustomerDemo.*
FROM
	gvwCustomerCustomerDemo
WHERE
	[CustomerID] = @CustomerID
	AND [CustomerTypeID] = @CustomerTypeID


GO
PRINT 'gspCustomerCustomerDemo_Update created'
GO


GRANT EXECUTE ON [gspCustomerCustomerDemo_Update] TO public
GO

/*
** gspCustomerDemographics_Update
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE gspCustomerDemographics_Update
(
	@CustomerTypeIDOriginal nchar(10), 
	@CustomerTypeID nchar(10),
	@CustomerDesc ntext
)
AS
/*
** Update a row in the CustomerDemographics table using the primary key
*/

UPDATE 
	[CustomerDemographics]
SET 
	[CustomerTypeID] = @CustomerTypeID
	,[CustomerDesc] = @CustomerDesc
WHERE
	[CustomerTypeID] = @CustomerTypeIDOriginal


/*
** Select the updated row
*/
SELECT
	gvwCustomerDemographics.*
FROM
	gvwCustomerDemographics
WHERE
	[CustomerTypeID] = @CustomerTypeID


GO
PRINT 'gspCustomerDemographics_Update created'
GO


GRANT EXECUTE ON [gspCustomerDemographics_Update] TO public
GO

/*
** gspCustomers_Update
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE gspCustomers_Update
(
	@CustomerIDOriginal nchar(5), 
	@CustomerID nchar(5),
	@CompanyName nvarchar(40),
	@ContactName nvarchar(30),
	@ContactTitle nvarchar(30),
	@Address nvarchar(60),
	@City nvarchar(15),
	@Region nvarchar(15),
	@PostalCode nvarchar(10),
	@Country nvarchar(15),
	@Phone nvarchar(24),
	@Fax nvarchar(24)
)
AS
/*
** Update a row in the Customers table using the primary key
*/

UPDATE 
	[Customers]
SET 
	[CustomerID] = @CustomerID
	,[CompanyName] = @CompanyName
	,[ContactName] = @ContactName
	,[ContactTitle] = @ContactTitle
	,[Address] = @Address
	,[City] = @City
	,[Region] = @Region
	,[PostalCode] = @PostalCode
	,[Country] = @Country
	,[Phone] = @Phone
	,[Fax] = @Fax
WHERE
	[CustomerID] = @CustomerIDOriginal


/*
** Select the updated row
*/
SELECT
	gvwCustomers.*
FROM
	gvwCustomers
WHERE
	[CustomerID] = @CustomerID


GO
PRINT 'gspCustomers_Update created'
GO


GRANT EXECUTE ON [gspCustomers_Update] TO public
GO

/*
** gspEmployees_Update
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE gspEmployees_Update
(
	@EmployeeIDOriginal int, 
	@EmployeeID int,
	@LastName nvarchar(20),
	@FirstName nvarchar(10),
	@Title nvarchar(30),
	@TitleOfCourtesy nvarchar(25),
	@BirthDate datetime,
	@HireDate datetime,
	@Address nvarchar(60),
	@City nvarchar(15),
	@Region nvarchar(15),
	@PostalCode nvarchar(10),
	@Country nvarchar(15),
	@HomePhone nvarchar(24),
	@Extension nvarchar(4),
	@Photo image,
	@Notes ntext,
	@ReportsTo int,
	@PhotoPath nvarchar(255)
)
AS
/*
** Update a row in the Employees table using the primary key
*/

UPDATE 
	[Employees]
SET 
	[LastName] = @LastName
	,[FirstName] = @FirstName
	,[Title] = @Title
	,[TitleOfCourtesy] = @TitleOfCourtesy
	,[BirthDate] = @BirthDate
	,[HireDate] = @HireDate
	,[Address] = @Address
	,[City] = @City
	,[Region] = @Region
	,[PostalCode] = @PostalCode
	,[Country] = @Country
	,[HomePhone] = @HomePhone
	,[Extension] = @Extension
	,[Photo] = @Photo
	,[Notes] = @Notes
	,[ReportsTo] = @ReportsTo
	,[PhotoPath] = @PhotoPath
WHERE
	[EmployeeID] = @EmployeeIDOriginal


/*
** Select the updated row
*/
SELECT
	gvwEmployees.*
FROM
	gvwEmployees
WHERE
	[EmployeeID] = @EmployeeID


GO
PRINT 'gspEmployees_Update created'
GO


GRANT EXECUTE ON [gspEmployees_Update] TO public
GO

/*
** gspEmployeeTerritories_Update
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE gspEmployeeTerritories_Update
(
	@EmployeeIDOriginal int, 
	@EmployeeID int,
	@TerritoryIDOriginal nvarchar(20), 
	@TerritoryID nvarchar(20)
)
AS
/*
** Update a row in the EmployeeTerritories table using the primary key
*/

UPDATE 
	[EmployeeTerritories]
SET 
	[EmployeeID] = @EmployeeID
	,[TerritoryID] = @TerritoryID
WHERE
	[EmployeeID] = @EmployeeIDOriginal
	AND [TerritoryID] = @TerritoryIDOriginal


/*
** Select the updated row
*/
SELECT
	gvwEmployeeTerritories.*
FROM
	gvwEmployeeTerritories
WHERE
	[EmployeeID] = @EmployeeID
	AND [TerritoryID] = @TerritoryID


GO
PRINT 'gspEmployeeTerritories_Update created'
GO


GRANT EXECUTE ON [gspEmployeeTerritories_Update] TO public
GO

/*
** gspOrderDetails_Update
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE gspOrderDetails_Update
(
	@OrderIDOriginal int, 
	@OrderID int,
	@ProductIDOriginal int, 
	@ProductID int,
	@UnitPrice money,
	@Quantity smallint,
	@Discount real
)
AS
/*
** Update a row in the Order Details table using the primary key
*/

UPDATE 
	[Order Details]
SET 
	[OrderID] = @OrderID
	,[ProductID] = @ProductID
	,[UnitPrice] = @UnitPrice
	,[Quantity] = @Quantity
	,[Discount] = @Discount
WHERE
	[OrderID] = @OrderIDOriginal
	AND [ProductID] = @ProductIDOriginal


/*
** Select the updated row
*/
SELECT
	gvwOrderDetails.*
FROM
	gvwOrderDetails
WHERE
	[OrderID] = @OrderID
	AND [ProductID] = @ProductID


GO
PRINT 'gspOrderDetails_Update created'
GO


GRANT EXECUTE ON [gspOrderDetails_Update] TO public
GO

/*
** gspOrders_Update
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE gspOrders_Update
(
	@OrderIDOriginal int, 
	@OrderID int,
	@CustomerID nchar(5),
	@EmployeeID int,
	@OrderDate datetime,
	@RequiredDate datetime,
	@ShippedDate datetime,
	@ShipVia int,
	@Freight money,
	@ShipName nvarchar(40),
	@ShipAddress nvarchar(60),
	@ShipCity nvarchar(15),
	@ShipRegion nvarchar(15),
	@ShipPostalCode nvarchar(10),
	@ShipCountry nvarchar(15)
)
AS
/*
** Update a row in the Orders table using the primary key
*/

UPDATE 
	[Orders]
SET 
	[CustomerID] = @CustomerID
	,[EmployeeID] = @EmployeeID
	,[OrderDate] = @OrderDate
	,[RequiredDate] = @RequiredDate
	,[ShippedDate] = @ShippedDate
	,[ShipVia] = @ShipVia
	,[Freight] = @Freight
	,[ShipName] = @ShipName
	,[ShipAddress] = @ShipAddress
	,[ShipCity] = @ShipCity
	,[ShipRegion] = @ShipRegion
	,[ShipPostalCode] = @ShipPostalCode
	,[ShipCountry] = @ShipCountry
WHERE
	[OrderID] = @OrderIDOriginal


/*
** Select the updated row
*/
SELECT
	gvwOrders.*
FROM
	gvwOrders
WHERE
	[OrderID] = @OrderID


GO
PRINT 'gspOrders_Update created'
GO


GRANT EXECUTE ON [gspOrders_Update] TO public
GO

/*
** gspProducts_Update
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE gspProducts_Update
(
	@ProductIDOriginal int, 
	@ProductID int,
	@ProductName nvarchar(40),
	@SupplierID int,
	@CategoryID int,
	@QuantityPerUnit nvarchar(20),
	@UnitPrice money,
	@UnitsInStock smallint,
	@UnitsOnOrder smallint,
	@ReorderLevel smallint,
	@Discontinued bit
)
AS
/*
** Update a row in the Products table using the primary key
*/

UPDATE 
	[Products]
SET 
	[ProductName] = @ProductName
	,[SupplierID] = @SupplierID
	,[CategoryID] = @CategoryID
	,[QuantityPerUnit] = @QuantityPerUnit
	,[UnitPrice] = @UnitPrice
	,[UnitsInStock] = @UnitsInStock
	,[UnitsOnOrder] = @UnitsOnOrder
	,[ReorderLevel] = @ReorderLevel
	,[Discontinued] = @Discontinued
WHERE
	[ProductID] = @ProductIDOriginal


/*
** Select the updated row
*/
SELECT
	gvwProducts.*
FROM
	gvwProducts
WHERE
	[ProductID] = @ProductID


GO
PRINT 'gspProducts_Update created'
GO


GRANT EXECUTE ON [gspProducts_Update] TO public
GO

/*
** gspRegion_Update
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE gspRegion_Update
(
	@RegionIDOriginal int, 
	@RegionID int,
	@RegionDescription nchar(50)
)
AS
/*
** Update a row in the Region table using the primary key
*/

UPDATE 
	[Region]
SET 
	[RegionID] = @RegionID
	,[RegionDescription] = @RegionDescription
WHERE
	[RegionID] = @RegionIDOriginal


/*
** Select the updated row
*/
SELECT
	gvwRegion.*
FROM
	gvwRegion
WHERE
	[RegionID] = @RegionID


GO
PRINT 'gspRegion_Update created'
GO


GRANT EXECUTE ON [gspRegion_Update] TO public
GO

/*
** gspShippers_Update
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE gspShippers_Update
(
	@ShipperIDOriginal int, 
	@ShipperID int,
	@CompanyName nvarchar(40),
	@Phone nvarchar(24)
)
AS
/*
** Update a row in the Shippers table using the primary key
*/

UPDATE 
	[Shippers]
SET 
	[CompanyName] = @CompanyName
	,[Phone] = @Phone
WHERE
	[ShipperID] = @ShipperIDOriginal


/*
** Select the updated row
*/
SELECT
	gvwShippers.*
FROM
	gvwShippers
WHERE
	[ShipperID] = @ShipperID


GO
PRINT 'gspShippers_Update created'
GO


GRANT EXECUTE ON [gspShippers_Update] TO public
GO

/*
** gspSuppliers_Update
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE gspSuppliers_Update
(
	@SupplierIDOriginal int, 
	@SupplierID int,
	@CompanyName nvarchar(40),
	@ContactName nvarchar(30),
	@ContactTitle nvarchar(30),
	@Address nvarchar(60),
	@City nvarchar(15),
	@Region nvarchar(15),
	@PostalCode nvarchar(10),
	@Country nvarchar(15),
	@Phone nvarchar(24),
	@Fax nvarchar(24),
	@HomePage ntext
)
AS
/*
** Update a row in the Suppliers table using the primary key
*/

UPDATE 
	[Suppliers]
SET 
	[CompanyName] = @CompanyName
	,[ContactName] = @ContactName
	,[ContactTitle] = @ContactTitle
	,[Address] = @Address
	,[City] = @City
	,[Region] = @Region
	,[PostalCode] = @PostalCode
	,[Country] = @Country
	,[Phone] = @Phone
	,[Fax] = @Fax
	,[HomePage] = @HomePage
WHERE
	[SupplierID] = @SupplierIDOriginal


/*
** Select the updated row
*/
SELECT
	gvwSuppliers.*
FROM
	gvwSuppliers
WHERE
	[SupplierID] = @SupplierID


GO
PRINT 'gspSuppliers_Update created'
GO


GRANT EXECUTE ON [gspSuppliers_Update] TO public
GO

/*
** gspTerritories_Update
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE gspTerritories_Update
(
	@TerritoryIDOriginal nvarchar(20), 
	@TerritoryID nvarchar(20),
	@TerritoryDescription nchar(50),
	@RegionID int
)
AS
/*
** Update a row in the Territories table using the primary key
*/

UPDATE 
	[Territories]
SET 
	[TerritoryID] = @TerritoryID
	,[TerritoryDescription] = @TerritoryDescription
	,[RegionID] = @RegionID
WHERE
	[TerritoryID] = @TerritoryIDOriginal


/*
** Select the updated row
*/
SELECT
	gvwTerritories.*
FROM
	gvwTerritories
WHERE
	[TerritoryID] = @TerritoryID


GO
PRINT 'gspTerritories_Update created'
GO


GRANT EXECUTE ON [gspTerritories_Update] TO public
GO
