/*
** 050_StoredProcedures_Delete.sql
**
** Drop and re-create the stored procedures used 
** when deleting rows from the database
**
** This script was automatically generated by
** Rad Software NextGeneration
**
** http://www.radsoftware.com.au/
**
*/

/*
** Connect to the NorthwindSample database
*/
USE [NorthwindSample]
GO

	
/*
** Drop gspCategories_Delete
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gspCategories_Delete'))
BEGIN
	PRINT 'gspCategories_Delete dropped'
	DROP PROCEDURE gspCategories_Delete
END	
GO
	
/*
** Drop gspCustomerCustomerDemo_Delete
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gspCustomerCustomerDemo_Delete'))
BEGIN
	PRINT 'gspCustomerCustomerDemo_Delete dropped'
	DROP PROCEDURE gspCustomerCustomerDemo_Delete
END	
GO
	
/*
** Drop gspCustomerDemographics_Delete
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gspCustomerDemographics_Delete'))
BEGIN
	PRINT 'gspCustomerDemographics_Delete dropped'
	DROP PROCEDURE gspCustomerDemographics_Delete
END	
GO
	
/*
** Drop gspCustomers_Delete
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gspCustomers_Delete'))
BEGIN
	PRINT 'gspCustomers_Delete dropped'
	DROP PROCEDURE gspCustomers_Delete
END	
GO
	
/*
** Drop gspEmployees_Delete
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gspEmployees_Delete'))
BEGIN
	PRINT 'gspEmployees_Delete dropped'
	DROP PROCEDURE gspEmployees_Delete
END	
GO
	
/*
** Drop gspEmployeeTerritories_Delete
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gspEmployeeTerritories_Delete'))
BEGIN
	PRINT 'gspEmployeeTerritories_Delete dropped'
	DROP PROCEDURE gspEmployeeTerritories_Delete
END	
GO
	
/*
** Drop gspOrderDetails_Delete
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gspOrderDetails_Delete'))
BEGIN
	PRINT 'gspOrderDetails_Delete dropped'
	DROP PROCEDURE gspOrderDetails_Delete
END	
GO
	
/*
** Drop gspOrders_Delete
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gspOrders_Delete'))
BEGIN
	PRINT 'gspOrders_Delete dropped'
	DROP PROCEDURE gspOrders_Delete
END	
GO
	
/*
** Drop gspProducts_Delete
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gspProducts_Delete'))
BEGIN
	PRINT 'gspProducts_Delete dropped'
	DROP PROCEDURE gspProducts_Delete
END	
GO
	
/*
** Drop gspRegion_Delete
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gspRegion_Delete'))
BEGIN
	PRINT 'gspRegion_Delete dropped'
	DROP PROCEDURE gspRegion_Delete
END	
GO
	
/*
** Drop gspShippers_Delete
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gspShippers_Delete'))
BEGIN
	PRINT 'gspShippers_Delete dropped'
	DROP PROCEDURE gspShippers_Delete
END	
GO
	
/*
** Drop gspSuppliers_Delete
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gspSuppliers_Delete'))
BEGIN
	PRINT 'gspSuppliers_Delete dropped'
	DROP PROCEDURE gspSuppliers_Delete
END	
GO
	
/*
** Drop gspTerritories_Delete
*/
IF EXISTS (SELECT name FROM sysobjects WHERE id = object_id('gspTerritories_Delete'))
BEGIN
	PRINT 'gspTerritories_Delete dropped'
	DROP PROCEDURE gspTerritories_Delete
END	
GO
	
/*
**
** Create the stored procedures used 
** when deleting rows from the database
**
**
*/

/*
** gspCategories_Delete
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE gspCategories_Delete
(
	@CategoryID int
)
AS
/*
** Delete a row from the Categories table
*/

DELETE 
FROM
	[Categories]
WHERE
	[CategoryID] = @CategoryID

IF @@ROWCOUNT = 0
BEGIN
	RAISERROR ('Delete failed: Zero rows were deleted from the Categories table', 16, 1)
END

GO
PRINT 'gspCategories_Delete created'
GO

GRANT EXECUTE ON [gspCategories_Delete] TO public

GO


/*
** gspCustomerCustomerDemo_Delete
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE gspCustomerCustomerDemo_Delete
(
	@CustomerID nchar(5),
	@CustomerTypeID nchar(10)
)
AS
/*
** Delete a row from the CustomerCustomerDemo table
*/

DELETE 
FROM
	[CustomerCustomerDemo]
WHERE
	[CustomerID] = @CustomerID
	AND [CustomerTypeID] = @CustomerTypeID

IF @@ROWCOUNT = 0
BEGIN
	RAISERROR ('Delete failed: Zero rows were deleted from the CustomerCustomerDemo table', 16, 1)
END

GO
PRINT 'gspCustomerCustomerDemo_Delete created'
GO

GRANT EXECUTE ON [gspCustomerCustomerDemo_Delete] TO public

GO


/*
** gspCustomerDemographics_Delete
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE gspCustomerDemographics_Delete
(
	@CustomerTypeID nchar(10)
)
AS
/*
** Delete a row from the CustomerDemographics table
*/

DELETE 
FROM
	[CustomerDemographics]
WHERE
	[CustomerTypeID] = @CustomerTypeID

IF @@ROWCOUNT = 0
BEGIN
	RAISERROR ('Delete failed: Zero rows were deleted from the CustomerDemographics table', 16, 1)
END

GO
PRINT 'gspCustomerDemographics_Delete created'
GO

GRANT EXECUTE ON [gspCustomerDemographics_Delete] TO public

GO


/*
** gspCustomers_Delete
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE gspCustomers_Delete
(
	@CustomerID nchar(5)
)
AS
/*
** Delete a row from the Customers table
*/

DELETE 
FROM
	[Customers]
WHERE
	[CustomerID] = @CustomerID

IF @@ROWCOUNT = 0
BEGIN
	RAISERROR ('Delete failed: Zero rows were deleted from the Customers table', 16, 1)
END

GO
PRINT 'gspCustomers_Delete created'
GO

GRANT EXECUTE ON [gspCustomers_Delete] TO public

GO


/*
** gspEmployees_Delete
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE gspEmployees_Delete
(
	@EmployeeID int
)
AS
/*
** Delete a row from the Employees table
*/

DELETE 
FROM
	[Employees]
WHERE
	[EmployeeID] = @EmployeeID

IF @@ROWCOUNT = 0
BEGIN
	RAISERROR ('Delete failed: Zero rows were deleted from the Employees table', 16, 1)
END

GO
PRINT 'gspEmployees_Delete created'
GO

GRANT EXECUTE ON [gspEmployees_Delete] TO public

GO


/*
** gspEmployeeTerritories_Delete
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE gspEmployeeTerritories_Delete
(
	@EmployeeID int,
	@TerritoryID nvarchar(20)
)
AS
/*
** Delete a row from the EmployeeTerritories table
*/

DELETE 
FROM
	[EmployeeTerritories]
WHERE
	[EmployeeID] = @EmployeeID
	AND [TerritoryID] = @TerritoryID

IF @@ROWCOUNT = 0
BEGIN
	RAISERROR ('Delete failed: Zero rows were deleted from the EmployeeTerritories table', 16, 1)
END

GO
PRINT 'gspEmployeeTerritories_Delete created'
GO

GRANT EXECUTE ON [gspEmployeeTerritories_Delete] TO public

GO


/*
** gspOrderDetails_Delete
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE gspOrderDetails_Delete
(
	@OrderID int,
	@ProductID int
)
AS
/*
** Delete a row from the Order Details table
*/

DELETE 
FROM
	[Order Details]
WHERE
	[OrderID] = @OrderID
	AND [ProductID] = @ProductID

IF @@ROWCOUNT = 0
BEGIN
	RAISERROR ('Delete failed: Zero rows were deleted from the Order Details table', 16, 1)
END

GO
PRINT 'gspOrderDetails_Delete created'
GO

GRANT EXECUTE ON [gspOrderDetails_Delete] TO public

GO


/*
** gspOrders_Delete
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE gspOrders_Delete
(
	@OrderID int
)
AS
/*
** Delete a row from the Orders table
*/

DELETE 
FROM
	[Orders]
WHERE
	[OrderID] = @OrderID

IF @@ROWCOUNT = 0
BEGIN
	RAISERROR ('Delete failed: Zero rows were deleted from the Orders table', 16, 1)
END

GO
PRINT 'gspOrders_Delete created'
GO

GRANT EXECUTE ON [gspOrders_Delete] TO public

GO


/*
** gspProducts_Delete
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE gspProducts_Delete
(
	@ProductID int
)
AS
/*
** Delete a row from the Products table
*/

DELETE 
FROM
	[Products]
WHERE
	[ProductID] = @ProductID

IF @@ROWCOUNT = 0
BEGIN
	RAISERROR ('Delete failed: Zero rows were deleted from the Products table', 16, 1)
END

GO
PRINT 'gspProducts_Delete created'
GO

GRANT EXECUTE ON [gspProducts_Delete] TO public

GO


/*
** gspRegion_Delete
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE gspRegion_Delete
(
	@RegionID int
)
AS
/*
** Delete a row from the Region table
*/

DELETE 
FROM
	[Region]
WHERE
	[RegionID] = @RegionID

IF @@ROWCOUNT = 0
BEGIN
	RAISERROR ('Delete failed: Zero rows were deleted from the Region table', 16, 1)
END

GO
PRINT 'gspRegion_Delete created'
GO

GRANT EXECUTE ON [gspRegion_Delete] TO public

GO


/*
** gspShippers_Delete
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE gspShippers_Delete
(
	@ShipperID int
)
AS
/*
** Delete a row from the Shippers table
*/

DELETE 
FROM
	[Shippers]
WHERE
	[ShipperID] = @ShipperID

IF @@ROWCOUNT = 0
BEGIN
	RAISERROR ('Delete failed: Zero rows were deleted from the Shippers table', 16, 1)
END

GO
PRINT 'gspShippers_Delete created'
GO

GRANT EXECUTE ON [gspShippers_Delete] TO public

GO


/*
** gspSuppliers_Delete
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE gspSuppliers_Delete
(
	@SupplierID int
)
AS
/*
** Delete a row from the Suppliers table
*/

DELETE 
FROM
	[Suppliers]
WHERE
	[SupplierID] = @SupplierID

IF @@ROWCOUNT = 0
BEGIN
	RAISERROR ('Delete failed: Zero rows were deleted from the Suppliers table', 16, 1)
END

GO
PRINT 'gspSuppliers_Delete created'
GO

GRANT EXECUTE ON [gspSuppliers_Delete] TO public

GO


/*
** gspTerritories_Delete
*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE gspTerritories_Delete
(
	@TerritoryID nvarchar(20)
)
AS
/*
** Delete a row from the Territories table
*/

DELETE 
FROM
	[Territories]
WHERE
	[TerritoryID] = @TerritoryID

IF @@ROWCOUNT = 0
BEGIN
	RAISERROR ('Delete failed: Zero rows were deleted from the Territories table', 16, 1)
END

GO
PRINT 'gspTerritories_Delete created'
GO

GRANT EXECUTE ON [gspTerritories_Delete] TO public

GO
