<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet 
	version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
	>

<xsl:output 
	method="text" 
	indent="no" 
	omit-xml-declaration="yes" 
	/>
<!-- 
//
// NextGeneration Template
// 
// Template Set:	Business Service Database Direct Wrapper
// Language:		.NET C#
// Template:		Business Service Database Direct Wrapper
//
// Copyright (c) Ross Donald 2003-2004
// http://www.radsoftware.com.au
//
-->

<!-- FileName = "{0}DatabaseDirectWrapper.cs" -->
<!-- Folder = "BusinessDatabaseDirectWrapper" -->

<xsl:param name="ObjectName" select="'Timesheet'"/>
<xsl:param name="Namespace" select="'NextGeneration'"/>

<!--
//
// Main Template
//
-->
<xsl:template match="/">

	<!-- 
	// Create the Business Service classes 
	-->	
	<xsl:apply-templates select="/db/Table[table_name_safe = $ObjectName]"/>	
	
</xsl:template>


<!--
//
// Create the Wrapper class
//
-->
<xsl:template match="Table">

	<xsl:text>
using System;
using System.Data;
using System.Xml;

using RAD.AppFramework.QueryObjects;

using </xsl:text><xsl:value-of select="$Namespace"/><xsl:text>.BusinessWebService;
using </xsl:text><xsl:value-of select="$Namespace"/><xsl:text>.BusinessServiceInterfaces;
using </xsl:text><xsl:value-of select="$Namespace"/><xsl:text>.Data;
using </xsl:text><xsl:value-of select="$Namespace"/><xsl:text>.DatabaseDirectWrapper.Base;

namespace </xsl:text>
<xsl:value-of select="$Namespace"/>
<xsl:text>.DatabaseDirectWrapper
{
	public class </xsl:text>
	<xsl:value-of select="table_name_safe" />
	<xsl:text>DatabaseDirectWrapper : </xsl:text>
	<xsl:value-of select="table_name_safe" />
	<xsl:text>DatabaseDirectWrapperBase, I</xsl:text>
	<xsl:value-of select="table_name_safe" />
	<xsl:text>Service 
	{
		#region Fields

		

		#endregion


		#region Constructors

		public </xsl:text><xsl:value-of select="table_name_safe" /><xsl:text>DatabaseDirectWrapper() : base() 
		{
		}
		

		#endregion


		#region  Public Properties



		#endregion


		#region Private Methods



		#endregion


		#region Public Methods



		#endregion

	
	}
}

</xsl:text>


</xsl:template>

</xsl:stylesheet>

