<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet 
	version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	>
<xsl:output 
	method="xml" 
	indent="yes" 
	omit-xml-declaration="yes"
	/>
<!-- 
//
// NextGeneration Template
// 
// Template Set:	Business Service Database Direct Wrapper
// Language:		.NET C#
// Template:		Visual Studio Project
//
// Copyright (c) Ross Donald 2003-2004
// http://www.radsoftware.com.au
//
-->

<!-- FileName = "BusinessDatabaseDirectWrapper.csproj" -->
<!-- Folder = "BusinessDatabaseDirectWrapper" -->

<xsl:param name="ObjectName" select="'NextGeneration'"/>
<xsl:param name="Namespace" select="'NextGeneration'"/>

<!--
//
// Main Template
//
-->
<xsl:template match="/">
	<VisualStudioProject>
		<CSHARP ProjectType="Local" ProductVersion="7.0.9466" SchemaVersion="1.0">
			<!-- ProjectGuid = "{29073BE0-C2C5-428C-833C-26DC2BE77787}" -->
			<Build>
				<Settings 
					ApplicationIcon="" 
					AssemblyKeyContainerName="" 
					AssemblyName="{$Namespace}.DatabaseDirectWrapper" 
					AssemblyOriginatorKeyFile="" 
					DefaultClientScript="JScript" 
					DefaultHTMLPageLayout="Grid" 
					DefaultTargetSchema="IE50" 
					DelaySign="false" 
					OutputType="Library" 
					RootNamespace="{$Namespace}.DatabaseDirectWrapper" 
					StartupObject="">
					
					<Config 
						Name="Debug" 
						AllowUnsafeBlocks="false" 
						BaseAddress="285212672" 
						CheckForOverflowUnderflow="false" 
						ConfigurationOverrideFile="" 
						DefineConstants="DEBUG;TRACE" 
						DocumentationFile="Doc\{$Namespace}.DatabaseDirectWrapper.xml" 
						DebugSymbols="true" 
						FileAlignment="4096" 
						IncrementalBuild="true" 
						Optimize="false" 
						OutputPath="bin\Debug\" 
						RegisterForComInterop="false" 
						RemoveIntegerChecks="false" 
						TreatWarningsAsErrors="false" 
						WarningLevel="4"/>
						
					<Config Name="Release" 
						AllowUnsafeBlocks="false" 
						BaseAddress="285212672" 
						CheckForOverflowUnderflow="false" 
						ConfigurationOverrideFile="" 
						DefineConstants="TRACE" 
						DocumentationFile="Doc\{$Namespace}.DatabaseDirectWrapper.xml" 
						DebugSymbols="false" 
						FileAlignment="4096" 
						IncrementalBuild="false" 
						Optimize="true" 
						OutputPath="bin\Release\" 
						RegisterForComInterop="false" 
						RemoveIntegerChecks="false" 
						TreatWarningsAsErrors="false" 
						WarningLevel="4"/>
				</Settings>
				
				<References>
				
            <Reference
                Name = "System.Data"
                AssemblyName = "System.Data"  
            />
            <Reference
                Name = "System"
                AssemblyName = "System" 
            />
            <Reference
                Name = "System.XML"
                AssemblyName = "System.XML"
            />
            <Reference
                Name = "System.Web.Services"
                AssemblyName = "System.Web.Services"
            />

	</References>
        
			</Build>
			<Files>
				<Include>

					<File
						RelPath = "AssemblyInfo.cs"
						SubType = "Code"
						BuildAction = "Compile"
						/>	
					
					<!-- 
					// Add all generated files to the project
					-->
					<xsl:for-each select="/db/Table[(starts-with(table_type, 'TABLE') or table_type='VIEW') and is_selected='true']">
						<xsl:apply-templates select="."/>
					</xsl:for-each>
				</Include>
			</Files>
		</CSHARP>
	</VisualStudioProject>
</xsl:template>


<!--
//
// Create an entry for the Business Logic Class file in the project file
//
-->
<xsl:template match="Table">
    <File
		RelPath = "{table_name_safe}DatabaseDirectWrapper.cs"
		SubType = "Code"
		BuildAction = "Compile"
		/>			
    <File
		RelPath = "Base\{table_name_safe}DatabaseDirectWrapperBase.cs"
		SubType = "Code"
		BuildAction = "Compile"
		/>
		
</xsl:template>


</xsl:stylesheet>
