<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet 
	version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
	>

<xsl:output 
	method="text" 
	indent="no" 
	omit-xml-declaration="yes" 
	/>
<!-- 
//
// NextGeneration Template
// 
// Template Set:	Business Service Interfaces
// Language:		.NET C#
// Template:		Business Service Interface
//
// Copyright (c) Ross Donald 2003-2004
// http://www.radsoftware.com.au
//
-->

<!-- FileName = "I{0}Service.cs" -->
<!-- Folder = "BusinessServiceInterfaces" -->

<xsl:param name="ObjectName" select="'Timesheet'"/>
<xsl:param name="Namespace" select="'NextGeneration'"/>

<!--
//
// Main Template
//
-->
<xsl:template match="/">

	<!-- 
	// Create the Business Service classes 
	-->	
	<xsl:apply-templates select="/db/Table[table_name_safe = $ObjectName]"/>	
	
</xsl:template>


<!--
//
// Create the IBusinessService class
//
-->
<xsl:template match="Table">

	<xsl:text>
using System;
using System.Data;

using RAD.AppFramework.QueryObjects;

using </xsl:text><xsl:value-of select="$Namespace"/><xsl:text>.Data;
using </xsl:text><xsl:value-of select="$Namespace"/><xsl:text>.BusinessServiceInterfaces.Base;

namespace </xsl:text>
<xsl:value-of select="$Namespace"/>
<xsl:text>.BusinessServiceInterfaces
{
	/// &lt;summary&gt;
	/// I</xsl:text>
	<xsl:value-of select="table_name_safe" />
	<xsl:text>Service defines the methods that must be provided by the Business service.
	/// &lt;/summary&gt;
	/// &lt;remarks&gt;
	/// Custom methods functionality can be added to this interface.
	/// &lt;br/&gt;&lt;br/&gt;
	/// This class was automatically generated by Rad Software NextGeneration &lt;a href="http://www.radsoftware.com.au"&gt;http://www.radsoftware.com.au&lt;/a&gt;
	/// &lt;/remarks&gt;
	public interface I</xsl:text><xsl:value-of select="table_name_safe" /><xsl:text>Service : I</xsl:text><xsl:value-of select="table_name_safe" /><xsl:text>ServiceBase
	{
		// Add extra business service methods here
	}
}

</xsl:text>


</xsl:template>
</xsl:stylesheet>

