<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet 
	version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
	>

<xsl:output 
	method="text" 
	indent="no" 
	omit-xml-declaration="yes" 
	/>
<!-- 
//
// NextGeneration Template
// 
// Template Set:	Business Service Web Service Wrapper
// Language:		.NET C#
// Template:		Business Service Web Service Wrapper
//
// Copyright (c) Ross Donald 2003-2004
// http://www.radsoftware.com.au
//
-->

<!-- FileName = "{0}WebServiceWrapper.vb" -->
<!-- Folder = "BusinessWebServiceWrapper" -->

<xsl:param name="ObjectName" select="'Timesheet'"/>
<xsl:param name="Namespace" select="'NextGeneration'"/>
<xsl:param name="BusinessWebServiceUseInterfaces" select="'false'"/>

<!--
//
// Template Parameters
//
-->
<xsl:template mode="Parameters" match="none">

<Parameter 
	KeyName="BusinessWebServiceUseInterfaces" 
	DisplayName="Use Interfaces" 
	Type="Boolean"
	Description="If true the wrapper classes will reference the Business Service Interfaces. If false the generated wrapper classes will not use interfaces." 
	DefaultValue="false" 
	ListType="None">
</Parameter>

</xsl:template>

<!--
//
// Main Template
//
-->
<xsl:template match="/">

	<!-- 
	// Create the Business Service classes 
	-->	
	<xsl:apply-templates select="/db/Table[table_name_safe = $ObjectName]"/>	
	
</xsl:template>


<!--
//
// Create the BusinessService Class
//
-->
<xsl:template match="Table">

	<xsl:text>
Imports System
Imports System.Data
Imports System.Xml
Imports System.Web.Services

Imports RAD.AppFramework.QueryObjects
</xsl:text>
<xsl:if test="$BusinessWebServiceUseInterfaces = 'true'">
<xsl:text>Imports </xsl:text><xsl:value-of select="$Namespace"/><xsl:text>.BusinessServiceInterfaces
</xsl:text>
</xsl:if>
<xsl:text>
Imports </xsl:text><xsl:value-of select="$Namespace"/><xsl:text>.Data
Imports </xsl:text><xsl:value-of select="$Namespace"/><xsl:text>.WebServiceWrapper.Base

Imports </xsl:text><xsl:value-of select="$Namespace"/><xsl:text>.WebServiceWrapper.</xsl:text><xsl:value-of select="table_name_safe"/><xsl:text>WebService

Public Class </xsl:text>
<xsl:value-of select="table_name_safe" />
<xsl:text>WebServiceWrapper 
	Inherits </xsl:text><xsl:value-of select="table_name_safe" /><xsl:text>WebServiceWrapperBase
		</xsl:text>
<xsl:if test="$BusinessWebServiceUseInterfaces = 'true'">
<xsl:text>Implements I</xsl:text><xsl:value-of select="table_name_safe" /><xsl:text>Service 
</xsl:text>
</xsl:if>
<xsl:text>
	
#Region "Fields"


#End Region


#Region "Constructors"

	Public Sub New(ByVal urlBase As String)
	
		MyBase.New(urlBase)
		
	End Sub
		

#End Region


#Region "Public Properties"



#End Region


#Region "Private Methods"



#End Region


#Region "Public Methods"



#End Region


End Class

</xsl:text>


</xsl:template>

</xsl:stylesheet>

