<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet 
	version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	>
<xsl:output 
	method="xml" 
	indent="yes" 
	omit-xml-declaration="yes"
	/>
<!-- 
//
// NextGeneration Template
// 
// Template Set:	Business Service Web Service Wrapper
// Language:		.NET C#
// Template:		Visual Studio Project
//
// Copyright (c) Ross Donald 2003-2004
// http://www.radsoftware.com.au
//
-->

<!-- FileName = "BusinessWebServiceWrapper.vbproj" -->
<!-- Folder = "BusinessWebServiceWrapper" -->

<xsl:param name="ObjectName" select="'NextGeneration'"/>
<xsl:param name="Namespace" select="'NextGeneration'"/>
<xsl:param name="BusinessWebServiceIISVirtualDirectory" select="'NextGenerationWebService'"/>

<!--
//
// Main Template
//
-->
<xsl:template match="/">
	<VisualStudioProject>
		<VisualBasic ProjectType="Local" ProductVersion="7.0.9466" SchemaVersion="1.0">
			<!-- ProjectGuid = "{29073BE0-C2C5-428C-833C-26DC2BE77787}" -->
			<Build>
				<Settings 
					ApplicationIcon="" 
					AssemblyKeyContainerName="" 
					AssemblyName="{$Namespace}.WebServiceWrapper" 
					AssemblyOriginatorKeyFile="" 
					DefaultClientScript="JScript" 
					DefaultHTMLPageLayout="Grid" 
					DefaultTargetSchema="IE50" 
					DelaySign="false" 
					OutputType="Library" 
					OptionCompare = "Binary"
					OptionExplicit = "On"
					OptionStrict = "On"
					RootNamespace="{$Namespace}.WebServiceWrapper" 
					StartupObject="">
					
					<Config 
						Name="Debug" 
						AllowUnsafeBlocks="false" 
						BaseAddress="285212672" 
						CheckForOverflowUnderflow="false" 
						ConfigurationOverrideFile="" 
						DefineDebug="true"
						DefineTrace="true"
						DefineConstants="" 
						DebugSymbols="true" 
						FileAlignment="4096" 
						IncrementalBuild="true" 
						Optimize="false" 
						OutputPath="bin\Debug\" 
						RegisterForComInterop="false" 
						RemoveIntegerChecks="false" 
						TreatWarningsAsErrors="false" 
						WarningLevel="4"/>
						
					<Config Name="Release" 
						AllowUnsafeBlocks="false" 
						BaseAddress="285212672" 
						DefineDebug = "false"
						DefineTrace = "true"
						CheckForOverflowUnderflow="false" 
						ConfigurationOverrideFile="" 
						DefineConstants="" 
						DebugSymbols="false" 
						FileAlignment="4096" 
						IncrementalBuild="false" 
						Optimize="true" 
						OutputPath="bin\Release\" 
						RegisterForComInterop="false" 
						RemoveIntegerChecks="false" 
						TreatWarningsAsErrors="false" 
						WarningLevel="4"/>
				</Settings>
				
				<References>
				
            <Reference
                Name = "System.Data"
                AssemblyName = "System.Data"  
            />
            <Reference
                Name = "System"
                AssemblyName = "System" 
            />
            <Reference
                Name = "System.XML"
                AssemblyName = "System.XML"
            />
            <Reference
                Name = "System.Web.Services"
                AssemblyName = "System.Web.Services"
            />

			</References>
			
			<Imports>
				<Import Namespace = "Microsoft.VisualBasic" />
				<Import Namespace = "System" />
				<Import Namespace = "System.Collections" />
				<Import Namespace = "System.Data" />
				<Import Namespace = "System.Diagnostics" />
				<!-- To workaround the problem with the proxy generated for Query -->
				<Import Namespace = "RAD.AppFramework.QueryObjects" />
			</Imports>
        
			</Build>
			<Files>
				<Include>
					<Folder
						RelPath = "Web References\"
						WebReferences = "TRUE"
						/>

					<File
						RelPath = "AssemblyInfo.vb"
						SubType = "Code"
						BuildAction = "Compile"
						/>	
					
					<!-- 
					// Add all generated files to the project
					-->
					<xsl:for-each select="/db/Table[(starts-with(table_type, 'TABLE') or table_type='VIEW') and is_selected='true']">
						<xsl:apply-templates select="."/>
					</xsl:for-each>
				</Include>
			</Files>
		</VisualBasic>
	</VisualStudioProject>
</xsl:template>


<!--
//
// Create an entry for the Business Logic Class file in the project file
//
-->
<xsl:template match="Table">
    <File
		RelPath = "{table_name_safe}WebServiceWrapper.vb"
		SubType = "Code"
		BuildAction = "Compile"
		/>			
    <File
		RelPath = "Base\{table_name_safe}WebServiceWrapperBase.vb"
		SubType = "Code"
		BuildAction = "Compile"
		/>	

	<!-- 
	// basics for a web reference 
	// 'Update web reference' will create the proxy
	-->		
	<Folder
		RelPath = "Web References\{table_name_safe}WebService\"
		WebReferenceUrl = "http://localhost/{$BusinessWebServiceIISVirtualDirectory}/{table_name_safe}Service.asmx"
		UrlBehavior = "Static"
        />
		
</xsl:template>


</xsl:stylesheet>
