<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet 
	version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
	>

<xsl:output 
	method="text" 
	indent="no" 
	omit-xml-declaration="yes" 
	/>
<!-- 
//
// NextGeneration Template
// 
// Template Set:	Data Retrieval Layer
// Language:		.NET C#
// Template:		Data Retrieval Sub Class
//
// Copyright (c) Ross Donald 2003-2004
// http://www.radsoftware.com.au
//
-->

<!-- FileName = "DataRetrievalFactory.cs" -->
<!-- Folder = "DataRetrieval" -->

<xsl:param name="ObjectName" select="'Timesheet'"/>
<xsl:param name="Namespace" select="'NextGeneration'"/>


<!--
//
// Create the DataRetrieval class
//
-->
<xsl:template match="/">

	<xsl:text>
using System;
using System.Configuration;

using </xsl:text><xsl:value-of select="$Namespace"/><xsl:text>.BusinessServiceInterfaces;

namespace </xsl:text><xsl:value-of select="$Namespace"/><xsl:text>.DataRetrieval
{
	public abstract class DataRetrievalFactory
	{
		public static DataRetrievalFactory GetDataRetrievalFactory() 
		{
			string sType = ConfigurationSettings.AppSettings["ConnectionType"];
			
			if (sType == "SqlConn")
			{
				return new DataRetrievalSqlConnection();
			}
			else
			{
				return new DataRetrievalWebService(ConfigurationSettings.AppSettings["WebServiceRootUrl"]);
			}
		}

	</xsl:text>
	<xsl:for-each select="/db/Table[(starts-with(table_type, 'TABLE') or table_type='VIEW') and is_selected='true']">
	<xsl:text>
		public abstract I</xsl:text><xsl:value-of select="table_name_safe"/><xsl:text>Service Create</xsl:text>
		<xsl:value-of select="table_name_safe"/><xsl:text>Service();
	</xsl:text>
	</xsl:for-each><xsl:text>
	}
}

</xsl:text>


</xsl:template>


</xsl:stylesheet>

