<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
	xmlns:asp="urn:microsoft:aspx"
	>
	
<xsl:import 
	href="WebUICommon.xsl" 
	/>
	
<xsl:output 
	method="xml" 
	indent="yes" 
	omit-xml-declaration="yes"
	/>
	
<!-- 
//
// NextGeneration Template
// 
// Template Set:	Web User Interface
// Language:		.NET C#
// Template:		Menu Component
//
// Copyright (c) Ross Donald 2003-2004
// http://www.radsoftware.com.au
//
-->

<!-- FileName = "Menu.ascx"	-->
<!-- Folder   = "WebUI\Components"			-->
	
<xsl:param name="ObjectName" select="'Employees'"/>
<xsl:param name="Namespace" select="'NextGeneration'"/>

<!--
//
// Main Template - Create a menu list
//
-->
<xsl:template match="/">
	
<xsl:text disable-output-escaping="yes">
&lt;%@ Control Language="C#" Codebehind="Menu.ascx.cs" Inherits="</xsl:text>
<xsl:value-of select="$Namespace"/>
<xsl:text disable-output-escaping="yes">.WebUI.Components.Menu" AutoEventWireup="false" TargetSchema="http://schemas.microsoft.com/intellisense/ie5" %&gt;
</xsl:text>
<div id="Menu">
	<ul>
		<li>
			<a href="Default.aspx">Home</a>
		</li>
		
		<xsl:for-each select="/db/Table[(starts-with(table_type, 'TABLE') or table_type='VIEW') and is_selected='true']">
			<li>
				<a href="{table_name_safe}_Search.aspx"><xsl:value-of select="table_name_friendly"/></a>
			</li>
		</xsl:for-each>
		
	</ul>
</div>	
	
</xsl:template>

</xsl:stylesheet>
