<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
	>
		
<xsl:output 
	method="text" 
	indent="no" 
	omit-xml-declaration="yes"
	/>
	
<!-- 
//
// NextGeneration Template
// 
// Template Set:	Web User Interface
// Language:		.NET C#
// Template:		Create a batch file that will call the script to create an IIS virtual directory
//
// Copyright (c) Ross Donald 2003-2004
// http://www.radsoftware.com.au
//
-->

<!-- FileName = "CreateIISApplication.bat"	-->
<!-- Folder   = "WebUI" -->
	
<xsl:param name="ObjectName" select="'Employees'"/>
<xsl:param name="Namespace" select="'NextGeneration'"/>
<xsl:param name="IISVirtualDirectory" select="'NextGenerationWebApp'"/>

<!--
//
// Template Parameters
//
-->
<xsl:template mode="Parameters" match="none">

<Parameter 
	KeyName="IISVirtualDirectory" 
	DisplayName="IIS Virtual Directory" 
	Type="String" 
	Description="Enter the virtual directory for your ASP.NET application. e.g. Entering 'MyWebApp' will create a web application on http://localhost/MyWebApp/  Do not use any special characters or spaces. A virtual directory name that uses only letters is recommended." 
	DefaultValue="MyWebApp" 
	ListType="None">
</Parameter>

</xsl:template>

<!--
//
// Main Template - Create a batch file
//
-->
<xsl:template match="/">
	
<xsl:text>
@ECHO OFF
CSCRIPT //Nologo %1\CreateIISApplication.vbs "</xsl:text><xsl:value-of select="$IISVirtualDirectory"/><xsl:text>" "%2"
IF [%ERRORLEVEL%]==[0] pause

</xsl:text>	
	
</xsl:template>
	
	
</xsl:stylesheet>
