<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
	xmlns:asp="urn:microsoft:aspx"
	>
	
<xsl:import 
	href="WebUICommon.xsl" 
	/>
	
<xsl:output 
	method="xml" 
	indent="yes" 
	omit-xml-declaration="yes"
	/>
	
<!-- 
//
// NextGeneration Template
// 
// Template Set:	Web User Interface
// Language:		.NET C#
// Template:		Search Page for a single Table
//
// Copyright (c) Ross Donald 2003-2004
// http://www.radsoftware.com.au
//
-->

<!-- FileName = "{0}_Search.aspx"	-->
<!-- Folder   = "WebUI"			-->
	
<xsl:param name="ObjectName" select="'Employees'"/>
<xsl:param name="Namespace" select="'NextGeneration'"/>

<!--
//
// Main Template
//
-->
<xsl:template match="/">
	
	<!-- 
	// Create a Search Results DataGrid
	-->
	<xsl:apply-templates select="/db/Table[table_name_safe = $ObjectName]" mode="DataGridSearchResults"/>
	
</xsl:template>


<!--
//
// Create a set of controls to search the table and a DataGrid to display the results
//
-->
<xsl:template match="Table" mode="DataGridSearchResults">

<xsl:text disable-output-escaping="yes">
&lt;%@ Register TagPrefix=&quot;uc1&quot; TagName=&quot;Header&quot; Src=&quot;Components/Header.ascx&quot; %&gt;
&lt;%@ Register TagPrefix=&quot;uc1&quot; TagName=&quot;Footer&quot; Src=&quot;Components/Footer.ascx&quot; %&gt;
&lt;%@ Page Language="C#" codebehind="</xsl:text>
<xsl:value-of select="table_name_safe"/>
<xsl:text disable-output-escaping="yes">_Search.aspx.cs" autoeventwireup="false" Inherits="</xsl:text>
<xsl:value-of select="$Namespace"/>
<xsl:text>.WebUI.</xsl:text>
<xsl:value-of select="table_name_safe"/>
<xsl:text disable-output-escaping="yes">_Search" Trace="False" %&gt;
&lt;!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" &gt;
</xsl:text>
	<html>
	<head>
		<title>
			<xsl:text disable-output-escaping="yes">&lt;%=PageTitle%&gt;</xsl:text>
		</title>
		<link href="Default.css" type="text/css" rel="stylesheet"/>
		<meta content="Microsoft Visual Studio 7.0" name="GENERATOR"/>
		<meta content="C#" name="CODE_LANGUAGE"/>
		<meta content="JavaScript" name="vs_defaultClientScript"/>
		<meta content="http://schemas.microsoft.com/intellisense/ie5" name="vs_targetSchema"/>
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
		<xsl:comment> Generated by Rad Software NextGeneration - http://www.radsoftware.com.au/ </xsl:comment>
	</head>
	<body>
		<form method="get">
		<xsl:text disable-output-escaping="yes">&lt;uc1:Header id=&quot;Header1&quot; runat=&quot;server&quot;&gt;&lt;/uc1:Header&gt;</xsl:text>
		<p>
		<asp:label id="lblMessage" CssClass="DataEntryFormMessage" Runat="server"></asp:label>
		</p>
		<br/>
		<table class="SearchForm" cellSpacing="0" cellPadding="2" border="0">
			<!-- 
			// Title row
			-->
			<tr class="SearchTitle">
				<td><xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text></td>
				<td colSpan="4" nowrap="nowrap">Search <xsl:value-of select="table_name_friendly"/></td>
			</tr>
			
			<!-- 
			// Row for each column to search on
			-->
			<xsl:for-each select="Column[data_type_native != 'timestamp' and data_type_clr != 'Byte[]']">
				
				<tr class="Criteria">
					<!-- padding column -->
					<td><xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text></td>
				
					<xsl:variable  name="search_type">
						<xsl:apply-templates select="." mode="SearchType"/>
					</xsl:variable>
					
					<xsl:choose>
						<!-- Boolean search field -->
						<xsl:when test="string($search_type) = 'Boolean'">
						
							<td>
								<xsl:value-of select="column_name_friendly"/> is 
							</td>
							<td>
								<select name="{column_name_safe}" id="{column_name_safe}" runat="server">
									<option value="" selected="">(anything)</option>
									<option value="true">Yes</option>
									<option value="false">No</option>
								</select>
							</td>
						
						</xsl:when>
						
						<!-- column ends in 'ID' -->
						<xsl:when test="string($search_type) = 'ID'">
						
							<td>
								<xsl:value-of select="column_name_friendly"/> is
							</td>
							<td>
								<input size="30" name="{column_name_safe}" id="{column_name_safe}" runat="server"/>
							</td>
						
						</xsl:when>
						
						<!-- String search field -->
						<xsl:when test="string($search_type) = 'String'">
						
							<td>
								<xsl:value-of select="column_name_friendly"/> contains
							</td>
							<td>
								<input size="30" name="{column_name_safe}" id="{column_name_safe}" runat="server"/>
							</td>
						
						</xsl:when>

						<!-- Numeric/date search field -->
						<xsl:when test="string($search_type) = 'Between' or string($search_type) = 'DateTime'">
						
							<td>
								<xsl:value-of select="column_name_friendly"/> between
							</td>
							<td>
								<input size="12" name="{column_name_safe}Begin" id="{column_name_safe}Begin" runat="server"/> 
								and
								<input size="12" name="{column_name_safe}End" id="{column_name_safe}End" runat="server"/>
							</td>
						
						</xsl:when>
						
						<!-- Can't search on Byte[] or Object columns -->
					</xsl:choose>
				
					<!-- padding cell -->
					<td><xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text></td>
				</tr>
				
			</xsl:for-each>
			
			<tr class="SearchFooter">
				<!-- padding column -->
				<td><xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text></td>
				<td></td>
				<td>
					<input type="submit" class="Button" value="Search" name="Action"/>
				</td>
				<td><xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text></td>	
			</tr>
			
		</table>

	</form>
	<br/>
	<form id="Form1" method="post" enctype="application/x-www-form-urlencoded" runat="server">
		<!-- 
		// Search results DataGrid 
		-->
		<asp:DataGrid 
			id="{table_name_safe}Grid" 
			runat="server" 
			GridLines="None" 
			CssClass="DataGrid" 
			AllowSorting="True" 
			PageSize="20" 
			AutoGenerateColumns="False" 
			AllowPaging="True" 
			DataKeyField="{Column[is_key = 'true'][1]/column_name_safe}"
			CellPadding="2" 
			CellSpacing="1"
			DataSource="{concat('&lt;%# m_', table_name_safe, 'DataSet %&gt;')}" 
			DataMember="{table_name_safe}"
			>
		
			<SelectedItemStyle verticalalign="Top" cssclass="DataGridItemSelected"/>
			<EditItemStyle verticalalign="Top" cssclass="DataGridItemEdit"/>
			<AlternatingItemStyle verticalalign="Top" cssclass="DataGridItemAlt"/>
			<ItemStyle verticalalign="Top" cssclass="DataGridItem"/>
			
			<HeaderStyle cssclass="DataGridHeader"/>
			<FooterStyle cssclass="DataGridFooter"/>
			
			<Columns>
				<asp:ButtonColumn Text="Edit" ButtonType="PushButton" HeaderText="" CommandName="Edit"/>

				<xsl:for-each select="Column">
					<xsl:apply-templates select="."/>
				</xsl:for-each>

			</Columns>
			
			<PagerStyle NextPageText="| Next Page &amp;gt;" PrevPageText="&amp;lt; Previous Page" CssClass="DataGridPager" Wrap="False"/>
			
		</asp:DataGrid>
		<xsl:text disable-output-escaping="yes">&lt;uc1:Footer id=&quot;Footer1&quot; runat=&quot;server&quot;&gt;&lt;/uc1:Footer&gt;</xsl:text>
	</form>
	</body>
	</html>
</xsl:template>


<!--
//
// Create a bound column for a Table column
//
-->	
<xsl:template match="Column">

<xsl:choose>
	
	<xsl:when test="data_type_clr = 'Boolean'">
	<asp:templatecolumn HeaderText="{column_name_friendly}">
		<headerstyle wrap="False"/>
		<itemstyle wrap="False" horizontalalign="Center"/>
		<itemtemplate>

		<xsl:text disable-output-escaping="yes">
		&lt;asp:CheckBox id="ctl</xsl:text>
		<xsl:value-of select="column_name_safe"/>
		<xsl:text disable-output-escaping="yes">View" runat="server" Checked='&lt;%# Convert.ToBoolean(DataBinder.Eval(Container, "DataItem.</xsl:text>
		<xsl:value-of select="column_name_safe"/>
		<xsl:text disable-output-escaping="yes">")) %&gt;' Enabled="False"&gt;
		&lt;/asp:checkbox&gt;
		</xsl:text>
		
<!--
		<xsl:text disable-output-escaping="yes">
		&lt;asp:Label id="ctl</xsl:text>
		<xsl:value-of select="column_name_safe"/>
		<xsl:text disable-output-escaping="yes">View" runat="server" Text='&lt;%# DataBinder.Eval(Container, "DataItem.</xsl:text>
		<xsl:value-of select="column_name_safe"/>
		<xsl:text disable-output-escaping="yes">", "{0:Yes/No}") %&gt;' Enabled="False"&gt;
		&lt;/asp:Label&gt;
		</xsl:text>
-->
		
		</itemtemplate>
	<footerstyle wrap="False"></footerstyle>
	<edititemtemplate>
	
			<xsl:text disable-output-escaping="yes">
		&lt;asp:CheckBox id="ctl</xsl:text>
		<xsl:value-of select="column_name_safe"/>
		<xsl:text disable-output-escaping="yes">Edit" runat="server" Checked='&lt;%# Convert.ToBoolean(DataBinder.Eval(Container, "DataItem.</xsl:text>
		<xsl:value-of select="column_name_safe"/>
		<xsl:text disable-output-escaping="yes">")) %&gt;' &gt;
		&lt;/asp:checkbox&gt;
		</xsl:text>
		
	</edititemtemplate>
	</asp:templatecolumn>	
	</xsl:when>
	
	<xsl:otherwise>
		<!--
		// Standard Bound Column
		-->
		<asp:BoundColumn 
			DataField="{column_name_safe}" 
			SortExpression="{column_name_safe}" 
			HeaderText="{column_name_friendly}">
			
			<!-- 
			// Make some columns Read only
			-->
			<xsl:choose>
				
				<xsl:when test="is_read_only = 'true' or is_auto_increment = 'true' or data_type_native = 'timestamp' or data_type_native = 'Object'">
					<!--
					// Make the column Read Only
					-->
					<xsl:attribute name="ReadOnly">true</xsl:attribute>
				</xsl:when>
				
			</xsl:choose>	
			
			<!-- 
			// Display Format
			-->
			<xsl:choose>
				
				<xsl:when test="contains(data_type_native, 'money') or data_type_native = 'Currency'">
					<!--
					// Displays number with thousand separator, if appropriate; 
					// display two digits to the right of the decimal separator. Output is based on system locale settings. 
					-->
					<xsl:attribute name="DataFormatString">{0:C}</xsl:attribute>
				</xsl:when>
				
				<!--
				// Displays number with thousand separator, at least one digit 
				// to the left and two digits to the right of the decimal separator.
				-->
				<xsl:when test="data_type_clr = 'Decimal' or data_type_clr = 'Double' or data_type_clr = 'Single'">
					<xsl:attribute name="DataFormatString">{0:N}</xsl:attribute>
				</xsl:when>
				
			</xsl:choose>
			
			<HeaderStyle wrap="False"/>

			<xsl:element name="ItemStyle">
			
				<!-- 
				// Dont wrap dates / datetimes
				-->
				<xsl:if test="data_type_clr = 'DateTime'">
					<xsl:attribute name="wrap">False</xsl:attribute>
				</xsl:if>
				
				<!-- 
				// Column alignment
				-->
				<xsl:choose>
					
					<xsl:when test="starts-with(data_type_clr, 'Int') or data_type_clr = 'Decimal' or data_type_clr = 'Double' or data_type_clr = 'Single' or data_type_clr = 'Byte'">
						<xsl:attribute name="horizontalalign">Right</xsl:attribute>
					</xsl:when>
					
					<xsl:when test="data_type_clr = 'Boolean'">
						<xsl:attribute name="horizontalalign">Center</xsl:attribute>
					</xsl:when>
					
				</xsl:choose>
 
			</xsl:element>			
			
		</asp:BoundColumn>
			
	</xsl:otherwise>
	
</xsl:choose>

</xsl:template>	
	
	
</xsl:stylesheet>
