<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
	xmlns:asp="urn:microsoft:aspx"
	>
		
<xsl:output 
	method="text" 
	indent="no" 
	omit-xml-declaration="yes"
	/>
	
<!-- 
//
// NextGeneration Template
// 
// Template Set:	Web User Interface
// Language:		.NET C#
// Template:		Web.config
//
// Copyright (c) Ross Donald 2003-2004
// http://www.radsoftware.com.au
//
-->

<!-- FileName = "Web.config"	-->
<!-- Folder   = "WebUI" -->
	
<xsl:param name="ObjectName" select="'Employees'"/>
<xsl:param name="Namespace" select="'NextGeneration'"/>
<xsl:param name="ConnectionString" select="'Provider=SQLOLEDB.1;Integrated Security=SSPI;Persist Security Info=False;Initial Catalog=NorthwindTest;Data Source=GRASSHOPPER'"/>


<!--
//
// Main Template
//
-->
<xsl:template match="/">
	
<xsl:text disable-output-escaping="yes">
&lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-8&quot; ?&gt;
&lt;configuration&gt;
	&lt;appSettings&gt;
		&lt;add 
			key=&quot;ConnectionString&quot; 
			value=&quot;</xsl:text>
			
			<xsl:choose>
				<xsl:when test="starts-with($ConnectionString, 'Provider=SQLOLEDB.1')">
					<xsl:value-of select="substring($ConnectionString, 21, string-length($ConnectionString)-19)"/>
				</xsl:when>
				
				<xsl:otherwise>
					<xsl:value-of select="$ConnectionString"/>
				</xsl:otherwise>
			</xsl:choose>
			
<xsl:text disable-output-escaping="yes">&quot;
			/&gt;
	&lt;/appSettings&gt;    	
	
  &lt;system.web&gt;

    &lt;!--  DYNAMIC DEBUG COMPILATION
          Set compilation debug=&quot;true&quot; to insert debugging symbols (.pdb information)
          into the compiled page. Because this creates a larger file that executes
          more slowly, you should set this value to true only when debugging and to
          false at all other times. For more information, refer to the documentation about
          debugging ASP.NET files.
    --&gt;
    &lt;compilation defaultLanguage=&quot;c#&quot; debug=&quot;true&quot; /&gt;

    &lt;!--  CUSTOM ERROR MESSAGES
          Set customErrors mode=&quot;On&quot; or &quot;RemoteOnly&quot; to enable custom error messages, &quot;Off&quot; to disable. 
          Add &lt;error&gt; tags for each of the errors you want to handle.

          &quot;On&quot; Always display custom (friendly) messages.
          &quot;Off&quot; Always display detailed ASP.NET error information.
          &quot;RemoteOnly&quot; Display custom (friendly) messages only to users not running 
           on the local Web server. This setting is recommended for security purposes, so 
           that you do not display application detail information to remote clients.
    --&gt;
    &lt;customErrors mode=&quot;RemoteOnly&quot; /&gt;

    &lt;!--  AUTHENTICATION 
          This section sets the authentication policies of the application. Possible modes are &quot;Windows&quot;, 
          &quot;Forms&quot;, &quot;Passport&quot; and &quot;None&quot;

          &quot;None&quot; No authentication is performed. 
          &quot;Windows&quot; IIS performs authentication (Basic, Digest, or Integrated Windows) according to 
           its settings for the application. Anonymous access must be disabled in IIS. 
          &quot;Forms&quot; You provide a custom form (Web page) for users to enter their credentials, and then 
           you authenticate them in your application. A user credential token is stored in a cookie.
          &quot;Passport&quot; Authentication is performed via a centralized authentication service provided
           by Microsoft that offers a single logon and core profile services for member sites.
    --&gt;
    &lt;authentication mode=&quot;Windows&quot; /&gt; 


    &lt;!--  AUTHORIZATION 
          This section sets the authorization policies of the application. You can allow or deny access
          to application resources by user or role. Wildcards: &quot;*&quot; mean everyone, &quot;?&quot; means anonymous 
          (unauthenticated) users.
    --&gt;
    &lt;authorization&gt;
        &lt;allow users=&quot;*&quot; /&gt; &lt;!-- Allow all users --&gt;

            &lt;!--  &lt;allow     users=&quot;[comma separated list of users]&quot;
                             roles=&quot;[comma separated list of roles]&quot;/&gt;
                  &lt;deny      users=&quot;[comma separated list of users]&quot;
                             roles=&quot;[comma separated list of roles]&quot;/&gt;
            --&gt;
    &lt;/authorization&gt;

    &lt;!--  APPLICATION-LEVEL TRACE LOGGING
          Application-level tracing enables trace log output for every page within an application. 
          Set trace enabled=&quot;true&quot; to enable application trace logging.  If pageOutput=&quot;true&quot;, the
          trace information will be displayed at the bottom of each page.  Otherwise, you can view the 
          application trace log by browsing the &quot;trace.axd&quot; page from your web application
          root. 
    --&gt;
    &lt;trace enabled=&quot;false&quot; requestLimit=&quot;10&quot; pageOutput=&quot;false&quot; traceMode=&quot;SortByTime&quot; localOnly=&quot;true&quot; /&gt;


    &lt;!--  SESSION STATE SETTINGS
          By default ASP.NET uses cookies to identify which requests belong to a particular session. 
          If cookies are not available, a session can be tracked by adding a session identifier to the URL. 
          To disable cookies, set sessionState cookieless=&quot;true&quot;.
    --&gt;
    &lt;sessionState 
            mode=&quot;InProc&quot;
            stateConnectionString=&quot;tcpip=127.0.0.1:42424&quot;
            sqlConnectionString=&quot;data source=127.0.0.1;Trusted_Connection=yes&quot;
            cookieless=&quot;false&quot; 
            timeout=&quot;20&quot; 
    /&gt;

    &lt;!--  GLOBALIZATION
          This section sets the globalization settings of the application. 
    --&gt;
    &lt;globalization requestEncoding=&quot;utf-8&quot; responseEncoding=&quot;utf-8&quot; /&gt;
   
  &lt;/system.web&gt;

&lt;/configuration&gt;
</xsl:text>	
	
</xsl:template>
	
	
</xsl:stylesheet>
