<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet 
	version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	>
<xsl:output 
	method="xml" 
	indent="yes" 
	omit-xml-declaration="yes"
	/>
<!-- 
//
// NextGeneration Template
// 
// Template Set:	Web User Interface
// Language:		.NET C#
// Template:		Visual Studio Project
//
// Copyright (c) Ross Donald 2003-2004
// http://www.radsoftware.com.au
//
-->
<!-- FileName = "WebUI.csproj" -->
<!-- Folder = "WebUI" -->

<xsl:param name="ObjectName" select="'NextGeneration'"/>
<xsl:param name="Namespace" select="'NextGeneration'"/>
	
<!--
//
// Main Template
//
-->
<xsl:template match="/">

	<VisualStudioProject>
    <CSHARP
        ProjectType = "Web"
        ProductVersion = "7.0.9466"
        SchemaVersion = "1.0"
    >
    <!-- ProjectGuid = "{4A034B25-F78F-4B0B-ADA8-2782A2D2C044}" -->
        <Build>
            <Settings
                ApplicationIcon = ""
                AssemblyKeyContainerName = ""
                AssemblyName = "{$Namespace}.WebUI"
                AssemblyOriginatorKeyFile = ""
                DefaultClientScript = "JScript"
                DefaultHTMLPageLayout = "Flow"
                DefaultTargetSchema = "IE50"
                DelaySign = "false"
                OutputType = "Library"
                RootNamespace = "{$Namespace}.WebUI"
                StartupObject = ""
            >
                <Config
                    Name = "Debug"
                    AllowUnsafeBlocks = "false"
                    BaseAddress = "285212672"
                    CheckForOverflowUnderflow = "false"
                    ConfigurationOverrideFile = ""
                    DefineConstants = "DEBUG;TRACE"
                    DocumentationFile = ""
                    DebugSymbols = "true"
                    FileAlignment = "4096"
                    IncrementalBuild = "true"
                    Optimize = "false"
                    OutputPath = "bin\"
                    RegisterForComInterop = "false"
                    RemoveIntegerChecks = "false"
                    TreatWarningsAsErrors = "false"
                    WarningLevel = "4"
                />
                <Config
                    Name = "Release"
                    AllowUnsafeBlocks = "false"
                    BaseAddress = "285212672"
                    CheckForOverflowUnderflow = "false"
                    ConfigurationOverrideFile = ""
                    DefineConstants = "TRACE"
                    DocumentationFile = ""
                    DebugSymbols = "false"
                    FileAlignment = "4096"
                    IncrementalBuild = "false"
                    Optimize = "true"
                    OutputPath = "bin\"
                    RegisterForComInterop = "false"
                    RemoveIntegerChecks = "false"
                    TreatWarningsAsErrors = "false"
                    WarningLevel = "4"
                />
            </Settings>
            <References>
                <Reference
                    Name = "System"
                    AssemblyName = "System"
                />
                <Reference
                    Name = "System.Drawing"
                    AssemblyName = "System.Drawing"
                />
                <Reference
                    Name = "System.Data"
                    AssemblyName = "System.Data"
                />
                <Reference
                    Name = "System.Web"
                    AssemblyName = "System.Web"
                />
                <Reference
                    Name = "System.XML"
                    AssemblyName = "System.Xml"
                />
               <Reference
                    Name = "System.Design"
                    AssemblyName = "System.Design"
                />
            </References>
        </Build>
        <Files>
            <Include>
				<Folder RelPath = "images\" />
				
                <!-- Standard files -->
                <File
                    RelPath = "AssemblyInfo.cs"
                    SubType = "Code"
                    BuildAction = "Compile"
                />
                 <File
                    RelPath = "Global.asax"
                    SubType = "Component"
                    BuildAction = "Content"
                />
                <File
                    RelPath = "Global.asax.cs"
                    DependentUpon = "Global.asax"
                    SubType = "Code"
                    BuildAction = "Compile"
                />
                <File
                    RelPath = "Web.config"
                    BuildAction = "Content"
                />
                <!-- Stylesheet -->
                <File
                    RelPath = "Default.css"
                    BuildAction = "Content"
                />
                
                <!-- Base page classes -->
                <File
                    RelPath = "BasePage.cs"
                    SubType = "ASPXCodeBehind"
                    BuildAction = "Compile"
                />
                <File
                    RelPath = "EditablePage.cs"
                    SubType = "ASPXCodeBehind"
                    BuildAction = "Compile"
                />
                 <File
                    RelPath = "SearchPage.cs"
                    SubType = "ASPXCodeBehind"
                    BuildAction = "Compile"
                />
                
                <!-- Default page -->
                <!--
				<File
                    RelPath = "Default.aspx"
                    SubType = "Form"
                    BuildAction = "Content"
                />
                <File
                    RelPath = "Default.aspx.cs"
                    DependentUpon = "Default.aspx"
                    SubType = "ASPXCodeBehind"
                    BuildAction = "Compile"
                />
                -->
                <!-- Menu Components -->
                <File
                    RelPath = "Components\Footer.ascx"
                    SubType = "UserControl"
                    BuildAction = "Content"
                />
                <File
                    RelPath = "Components\Footer.ascx.cs"
                    DependentUpon = "Footer.ascx"
                    SubType = "ASPXCodeBehind"
                    BuildAction = "Compile"
                />
                <File
                    RelPath = "Components\Header.ascx"
                    SubType = "UserControl"
                    BuildAction = "Content"
                />
                <File
                    RelPath = "Components\Header.ascx.cs"
                    DependentUpon = "Header.ascx"
                    SubType = "ASPXCodeBehind"
                    BuildAction = "Compile"
                />
                <File
                    RelPath = "Components\Menu.ascx"
                    SubType = "UserControl"
                    BuildAction = "Content"
                />
                <File
                    RelPath = "Components\Menu.ascx.cs"
                    DependentUpon = "Menu.ascx"
                    SubType = "ASPXCodeBehind"
                    BuildAction = "Compile"
                />
               
                <!-- 
				// Add all generated files to the project
				-->
				<xsl:for-each select="/db/Table[(starts-with(table_type, 'TABLE') or table_type='VIEW') and is_selected='true']">
					<File
						RelPath = "{table_name_safe}.aspx"
						BuildAction = "Content"
					/>
					<File
						RelPath = "{table_name_safe}.aspx.cs"
						DependentUpon = "{table_name_safe}.aspx"
						SubType = "ASPXCodeBehind"
						BuildAction = "Compile"
					/>
					<File
						RelPath = "{table_name_safe}_Search.aspx"
						BuildAction = "Content"
					/>
					<File
						RelPath = "{table_name_safe}_Search.aspx.cs"
						DependentUpon = "{table_name_safe}_Search.aspx"
						SubType = "ASPXCodeBehind"
						BuildAction = "Compile"
					/>
				</xsl:for-each>
				
            </Include>
        </Files>
    </CSHARP>
</VisualStudioProject>

</xsl:template>


</xsl:stylesheet>
